=== modified file 'configure.ac'
--- configure.ac	2012-03-07 21:22:18 +0000
+++ configure.ac	2012-03-18 18:58:06 +0000
@@ -1,5 +1,5 @@
 AC_INIT([indicator-appmenu],
-        [0.3.92],
+        [0.3.94],
         [http://bugs.launchpad.net/indicator-appmenu],
         [indicator-appmenu],
         [http://launchpad.net/indicator-appmenu])

=== modified file 'debian/changelog'
--- debian/changelog	2012-03-08 16:46:48 +0000
+++ debian/changelog	2012-03-18 18:58:06 +0000
@@ -1,3 +1,10 @@
+indicator-appmenu (0.3.92-0ubuntu1~ppa3~gmm1) UNRELEASED; urgency=low
+
+  * Upstream Merge
+    * GMenuModel menu support
+
+ -- Ted Gould <ted@ubuntu.com>  Sun, 18 Mar 2012 13:57:41 -0500
+
 indicator-appmenu (0.3.92-0ubuntu1~ppa2) precise; urgency=low
 
   * Upstream Merge

=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2012-03-06 19:40:56 +0000
+++ po/POTFILES.in	2012-03-16 14:48:19 +0000
@@ -1,19 +1,15 @@
 data/com.canonical.indicator.appmenu.gschema.xml.in
 data/com.canonical.indicator.appmenu.hud.gschema.xml.in
 data/com.canonical.indicator.appmenu.hud.search.gschema.xml.in
-src/create-db.c
 src/distance.c
 src/dump-app-info.c
 src/gdk-get-func.c
-src/gen-application-menu-registrar.xml.c
-src/gen-application-menu-renderer.xml.c
 src/hudappindicatorsource.c
 src/hudappmenuregistrar.c
 src/hud-cli.c
 src/huddbusmenucollector.c
 src/hud-dump-application.c
 src/hudindicatorsource.c
-src/hud.interface.c
 src/huditem.c
 src/hudmenumodelcollector.c
 src/hudquery.c
@@ -25,7 +21,8 @@
 src/hud-verify-app-info.c
 src/hudwindowsource.c
 src/indicator-appmenu.c
-src/indicator-appmenu-marshal.c
 src/load-app-info.c
 src/usage-tracker.c
-src/window-menus.c
+src/window-menu.c
+src/window-menu-dbusmenu.c
+src/window-menu-model.c

=== modified file 'po/POTFILES.skip'
--- po/POTFILES.skip	2012-03-06 19:40:56 +0000
+++ po/POTFILES.skip	2012-03-07 22:04:11 +0000
@@ -1,1 +1,6 @@
+src/create-db.c
+src/gen-application-menu-registrar.xml.c
+src/gen-application-menu-renderer.xml.c
 src/hud-gtk.ui
+src/hud.interface.c
+src/indicator-appmenu-marshal.c

=== modified file 'src/Makefile.am'
--- src/Makefile.am	2012-03-07 21:22:18 +0000
+++ src/Makefile.am	2012-03-18 18:58:06 +0000
@@ -29,12 +29,22 @@
 	MwmUtil.h \
 	indicator-appmenu.c \
 	indicator-appmenu-marshal.c \
-	window-menus.c \
-	window-menus.h \
+	window-menu.c \
+	window-menu.h \
+	window-menu-dbusmenu.c \
+	window-menu-dbusmenu.h \
+	window-menu-model.c \
+	window-menu-model.h \
 	gen-application-menu-renderer.xml.c \
 	gen-application-menu-renderer.xml.h \
 	gen-application-menu-registrar.xml.c \
-	gen-application-menu-registrar.xml.h
+	gen-application-menu-registrar.xml.h \
+	gactionmuxer.c \
+	gactionmuxer.h \
+	gactionobservable.c \
+	gactionobservable.h \
+	gactionobserver.c \
+	gactionobserver.h    
 libappmenu_la_CFLAGS = \
 	$(INDICATOR_CFLAGS) \
 	$(COVERAGE_CFLAGS) \

=== added file 'src/gactionmuxer.c'
--- src/gactionmuxer.c	1970-01-01 00:00:00 +0000
+++ src/gactionmuxer.c	2012-03-18 15:43:27 +0000
@@ -0,0 +1,493 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the licence, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#include "config.h"
+
+#include "gactionmuxer.h"
+
+#include "gactionobservable.h"
+#include "gactionobserver.h"
+
+#include <string.h>
+
+/*
+ * SECTION:gactionmuxer
+ * @short_description: Aggregate and monitor several action groups
+ *
+ * #GActionMuxer is a #GActionGroup and #GActionObservable that is
+ * capable of containing other #GActionGroup instances.
+ *
+ * The typical use is aggregating all of the actions applicable to a
+ * particular context into a single action group, with namespacing.
+ *
+ * Consider the case of two action groups -- one containing actions
+ * applicable to an entire application (such as 'quit') and one
+ * containing actions applicable to a particular window in the
+ * application (such as 'fullscreen').
+ *
+ * In this case, each of these action groups could be added to a
+ * #GActionMuxer with the prefixes "app" and "win", respectively.  This
+ * would expose the actions as "app.quit" and "win.fullscreen" on the
+ * #GActionGroup interface presented by the #GActionMuxer.
+ *
+ * Activations and state change requests on the #GActionMuxer are wired
+ * through to the underlying action group in the expected way.
+ *
+ * This class is typically only used at the site of "consumption" of
+ * actions (eg: when displaying a menu that contains many actions on
+ * different objects).
+ */
+
+static void     g_action_muxer_group_iface_init         (GActionGroupInterface      *iface);
+static void     g_action_muxer_observable_iface_init    (GActionObservableInterface *iface);
+
+typedef GObjectClass GActionMuxerClass;
+
+struct _GActionMuxer
+{
+  GObject parent_instance;
+
+  GHashTable *actions;
+  GHashTable *groups;
+};
+
+G_DEFINE_TYPE_WITH_CODE (GActionMuxer, g_action_muxer, G_TYPE_OBJECT,
+                         G_IMPLEMENT_INTERFACE (G_TYPE_ACTION_GROUP, g_action_muxer_group_iface_init)
+                         G_IMPLEMENT_INTERFACE (G_TYPE_ACTION_OBSERVABLE, g_action_muxer_observable_iface_init))
+
+typedef struct
+{
+  GActionMuxer *muxer;
+  GSList       *watchers;
+  gchar        *fullname;
+} Action;
+
+typedef struct
+{
+  GActionMuxer *muxer;
+  GActionGroup *group;
+  gchar        *prefix;
+  gulong        handler_ids[4];
+} Group;
+
+static gchar **
+g_action_muxer_list_actions (GActionGroup *action_group)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (action_group);
+
+  return (gchar **) muxer->groups;
+}
+
+static Group *
+g_action_muxer_find_group (GActionMuxer  *muxer,
+                              const gchar     **name)
+{
+  const gchar *dot;
+  gchar *prefix;
+  Group *group;
+
+  dot = strchr (*name, '.');
+
+  if (!dot)
+    return NULL;
+
+  prefix = g_strndup (*name, dot - *name);
+  group = g_hash_table_lookup (muxer->groups, prefix);
+  g_free (prefix);
+
+  *name = dot + 1;
+
+  return group;
+}
+
+static Action *
+g_action_muxer_lookup_action (GActionMuxer  *muxer,
+                              const gchar   *prefix,
+                              const gchar   *action_name,
+                              gchar        **fullname)
+{
+  Action *action;
+
+  *fullname = g_strconcat (prefix, ".", action_name, NULL);
+  action = g_hash_table_lookup (muxer->actions, *fullname);
+
+  return action;
+}
+
+static void
+g_action_muxer_action_enabled_changed (GActionGroup *action_group,
+                                       const gchar  *action_name,
+                                       gboolean      enabled,
+                                       gpointer      user_data)
+{
+  Group *group = user_data;
+  gchar *fullname;
+  Action *action;
+  GSList *node;
+
+  action = g_action_muxer_lookup_action (group->muxer, group->prefix, action_name, &fullname);
+  for (node = action ? action->watchers : NULL; node; node = node->next)
+    g_action_observer_action_enabled_changed (node->data, G_ACTION_OBSERVABLE (group->muxer), fullname, enabled);
+  g_action_group_action_enabled_changed (G_ACTION_GROUP (group->muxer), fullname, enabled);
+  g_free (fullname);
+}
+
+static void
+g_action_muxer_action_state_changed (GActionGroup *action_group,
+                                     const gchar  *action_name,
+                                     GVariant     *state,
+                                     gpointer      user_data)
+{
+  Group *group = user_data;
+  gchar *fullname;
+  Action *action;
+  GSList *node;
+
+  action = g_action_muxer_lookup_action (group->muxer, group->prefix, action_name, &fullname);
+  for (node = action ? action->watchers : NULL; node; node = node->next)
+    g_action_observer_action_state_changed (node->data, G_ACTION_OBSERVABLE (group->muxer), fullname, state);
+  g_action_group_action_state_changed (G_ACTION_GROUP (group->muxer), fullname, state);
+  g_free (fullname);
+}
+
+static void
+g_action_muxer_action_added (GActionGroup *action_group,
+                             const gchar  *action_name,
+                             gpointer      user_data)
+{
+  const GVariantType *parameter_type;
+  Group *group = user_data;
+  gboolean enabled;
+  GVariant *state;
+
+  if (g_action_group_query_action (group->group, action_name, &enabled, &parameter_type, NULL, NULL, &state))
+    {
+      gchar *fullname;
+      Action *action;
+      GSList *node;
+
+      action = g_action_muxer_lookup_action (group->muxer, group->prefix, action_name, &fullname);
+
+      for (node = action ? action->watchers : NULL; node; node = node->next)
+        g_action_observer_action_added (node->data,
+                                        G_ACTION_OBSERVABLE (group->muxer),
+                                        fullname, parameter_type, enabled, state);
+
+      g_action_group_action_added (G_ACTION_GROUP (group->muxer), fullname);
+
+      if (state)
+        g_variant_unref (state);
+
+      g_free (fullname);
+    }
+}
+
+static void
+g_action_muxer_action_removed (GActionGroup *action_group,
+                               const gchar  *action_name,
+                               gpointer      user_data)
+{
+  Group *group = user_data;
+  gchar *fullname;
+  Action *action;
+  GSList *node;
+
+  action = g_action_muxer_lookup_action (group->muxer, group->prefix, action_name, &fullname);
+  for (node = action ? action->watchers : NULL; node; node = node->next)
+    g_action_observer_action_removed (node->data, G_ACTION_OBSERVABLE (group->muxer), fullname);
+  g_action_group_action_removed (G_ACTION_GROUP (group->muxer), fullname);
+  g_free (fullname);
+}
+
+static gboolean
+g_action_muxer_query_action (GActionGroup        *action_group,
+                             const gchar         *action_name,
+                             gboolean            *enabled,
+                             const GVariantType **parameter_type,
+                             const GVariantType **state_type,
+                             GVariant           **state_hint,
+                             GVariant           **state)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (action_group);
+  Group *group;
+
+  group = g_action_muxer_find_group (muxer, &action_name);
+
+  if (!group)
+    return FALSE;
+
+  return g_action_group_query_action (group->group, action_name, enabled,
+                                      parameter_type, state_type, state_hint, state);
+}
+
+static void
+g_action_muxer_activate_action (GActionGroup *action_group,
+                                const gchar  *action_name,
+                                GVariant     *parameter)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (action_group);
+  Group *group;
+
+  group = g_action_muxer_find_group (muxer, &action_name);
+
+  if (group)
+    g_action_group_activate_action (group->group, action_name, parameter);
+}
+
+static void
+g_action_muxer_change_action_state (GActionGroup *action_group,
+                                    const gchar  *action_name,
+                                    GVariant     *state)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (action_group);
+  Group *group;
+
+  group = g_action_muxer_find_group (muxer, &action_name);
+
+  if (group)
+    g_action_group_change_action_state (group->group, action_name, state);
+}
+
+static void
+g_action_muxer_unregister_internal (Action   *action,
+                                    gpointer  observer)
+{
+  GActionMuxer *muxer = action->muxer;
+  GSList **ptr;
+
+  for (ptr = &action->watchers; *ptr; ptr = &(*ptr)->next)
+    if ((*ptr)->data == observer)
+      {
+        *ptr = g_slist_remove (*ptr, observer);
+
+        if (action->watchers == NULL)
+          {
+            g_hash_table_remove (muxer->actions, action->fullname);
+            g_free (action->fullname);
+
+            g_slice_free (Action, action);
+
+            g_object_unref (muxer);
+          }
+
+        break;
+      }
+}
+
+static void
+g_action_muxer_weak_notify (gpointer  data,
+                            GObject  *where_the_object_was)
+{
+  Action *action = data;
+
+  g_action_muxer_unregister_internal (action, where_the_object_was);
+}
+
+static void
+g_action_muxer_register_observer (GActionObservable *observable,
+                                  const gchar       *name,
+                                  GActionObserver   *observer)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (observable);
+  Action *action;
+
+  action = g_hash_table_lookup (muxer->actions, name);
+
+  if (action == NULL)
+    {
+      action = g_slice_new (Action);
+      action->muxer = g_object_ref (muxer);
+      action->fullname = g_strdup (name);
+      action->watchers = NULL;
+
+      g_hash_table_insert (muxer->actions, action->fullname, action);
+    }
+
+  action->watchers = g_slist_prepend (action->watchers, observer);
+  g_object_weak_ref (G_OBJECT (observer), g_action_muxer_weak_notify, action);
+}
+
+static void
+g_action_muxer_unregister_observer (GActionObservable *observable,
+                                    const gchar       *name,
+                                    GActionObserver   *observer)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (observable);
+  Action *action;
+
+  action = g_hash_table_lookup (muxer->actions, name);
+  g_object_weak_unref (G_OBJECT (observer), g_action_muxer_weak_notify, action);
+  g_action_muxer_unregister_internal (action, observer);
+}
+
+static void
+g_action_muxer_free_group (gpointer data)
+{
+  Group *group = data;
+
+  g_object_unref (group->group);
+  g_free (group->prefix);
+
+  g_slice_free (Group, group);
+}
+
+static void
+g_action_muxer_finalize (GObject *object)
+{
+  GActionMuxer *muxer = G_ACTION_MUXER (object);
+
+  g_assert_cmpint (g_hash_table_size (muxer->actions), ==, 0);
+  g_hash_table_unref (muxer->actions);
+  g_hash_table_unref (muxer->groups);
+
+  G_OBJECT_CLASS (g_action_muxer_parent_class)
+    ->finalize (object);
+}
+
+static void
+g_action_muxer_init (GActionMuxer *muxer)
+{
+  muxer->actions = g_hash_table_new (g_str_hash, g_str_equal);
+  muxer->groups = g_hash_table_new_full (g_str_hash, g_str_equal, NULL, g_action_muxer_free_group);
+}
+
+static void
+g_action_muxer_observable_iface_init (GActionObservableInterface *iface)
+{
+  iface->register_observer = g_action_muxer_register_observer;
+  iface->unregister_observer = g_action_muxer_unregister_observer;
+}
+
+static void
+g_action_muxer_group_iface_init (GActionGroupInterface *iface)
+{
+  iface->list_actions = g_action_muxer_list_actions;
+  iface->query_action = g_action_muxer_query_action;
+  iface->activate_action = g_action_muxer_activate_action;
+  iface->change_action_state = g_action_muxer_change_action_state;
+}
+
+static void
+g_action_muxer_class_init (GObjectClass *class)
+{
+  class->finalize = g_action_muxer_finalize;
+}
+
+/*
+ * g_action_muxer_insert:
+ * @muxer: a #GActionMuxer
+ * @prefix: the prefix string for the action group
+ * @action_group: a #GActionGroup
+ *
+ * Adds the actions in @action_group to the list of actions provided by
+ * @muxer.  @prefix is prefixed to each action name, such that for each
+ * action <varname>x</varname> in @action_group, there is an equivalent
+ * action @prefix<literal>.</literal><varname>x</varname> in @muxer.
+ *
+ * For example, if @prefix is "<literal>app</literal>" and @action_group
+ * contains an action called "<literal>quit</literal>", then @muxer will
+ * now contain an action called "<literal>app.quit</literal>".
+ *
+ * If any #GActionObservers are registered for actions in the group,
+ * "action_added" notifications will be emitted, as appropriate.
+ *
+ * @prefix must not contain a dot ('.').
+ */
+void
+g_action_muxer_insert (GActionMuxer *muxer,
+                       const gchar  *prefix,
+                       GActionGroup *action_group)
+{
+  gchar **actions;
+  Group *group;
+  gint i;
+
+  /* TODO: diff instead of ripout and replace */
+  g_action_muxer_remove (muxer, prefix);
+
+  group = g_slice_new (Group);
+  group->muxer = muxer;
+  group->group = g_object_ref (action_group);
+  group->prefix = g_strdup (prefix);
+
+  g_hash_table_insert (muxer->groups, group->prefix, group);
+
+  actions = g_action_group_list_actions (group->group);
+  for (i = 0; actions[i]; i++)
+    g_action_muxer_action_added (group->group, actions[i], group);
+  g_strfreev (actions);
+
+  group->handler_ids[0] = g_signal_connect (group->group, "action-added",
+                                            G_CALLBACK (g_action_muxer_action_added), group);
+  group->handler_ids[1] = g_signal_connect (group->group, "action-removed",
+                                            G_CALLBACK (g_action_muxer_action_removed), group);
+  group->handler_ids[2] = g_signal_connect (group->group, "action-enabled-changed",
+                                            G_CALLBACK (g_action_muxer_action_enabled_changed), group);
+  group->handler_ids[3] = g_signal_connect (group->group, "action-state-changed",
+                                            G_CALLBACK (g_action_muxer_action_state_changed), group);
+}
+
+/*
+ * g_action_muxer_remove:
+ * @muxer: a #GActionMuxer
+ * @prefix: the prefix of the action group to remove
+ *
+ * Removes a #GActionGroup from the #GActionMuxer.
+ *
+ * If any #GActionObservers are registered for actions in the group,
+ * "action_removed" notifications will be emitted, as appropriate.
+ */
+void
+g_action_muxer_remove (GActionMuxer *muxer,
+                       const gchar  *prefix)
+{
+  Group *group;
+
+  group = g_hash_table_lookup (muxer->groups, prefix);
+
+  if (group != NULL)
+    {
+      gchar **actions;
+      gint i;
+
+      g_hash_table_steal (muxer->groups, prefix);
+
+      actions = g_action_group_list_actions (group->group);
+      for (i = 0; actions[i]; i++)
+        g_action_muxer_action_removed (group->group, actions[i], group);
+      g_strfreev (actions);
+
+      /* 'for loop' or 'four loop'? */
+      for (i = 0; i < 4; i++)
+        g_signal_handler_disconnect (group->group, group->handler_ids[i]);
+
+      g_action_muxer_free_group (group);
+    }
+}
+
+/*
+ * g_action_muxer_new:
+ *
+ * Creates a new #GActionMuxer.
+ */
+GActionMuxer *
+g_action_muxer_new (void)
+{
+  return g_object_new (G_TYPE_ACTION_MUXER, NULL);
+}

=== added file 'src/gactionmuxer.h'
--- src/gactionmuxer.h	1970-01-01 00:00:00 +0000
+++ src/gactionmuxer.h	2012-03-18 15:43:27 +0000
@@ -0,0 +1,51 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the licence, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#ifndef __G_ACTION_MUXER_H__
+#define __G_ACTION_MUXER_H__
+
+#include <gio/gio.h>
+
+G_BEGIN_DECLS
+
+#define G_TYPE_ACTION_MUXER                                 (g_action_muxer_get_type ())
+#define G_ACTION_MUXER(inst)                                (G_TYPE_CHECK_INSTANCE_CAST ((inst),                     \
+                                                             G_TYPE_ACTION_MUXER, GActionMuxer))
+#define G_IS_ACTION_MUXER(inst)                             (G_TYPE_CHECK_INSTANCE_TYPE ((inst),                     \
+                                                             G_TYPE_ACTION_MUXER))
+
+typedef struct _GActionMuxer                                GActionMuxer;
+
+G_GNUC_INTERNAL
+GType                   g_action_muxer_get_type                         (void);
+G_GNUC_INTERNAL
+GActionMuxer *          g_action_muxer_new                              (void);
+
+G_GNUC_INTERNAL
+void                    g_action_muxer_insert                           (GActionMuxer *muxer,
+                                                                         const gchar  *prefix,
+                                                                         GActionGroup *group);
+
+G_GNUC_INTERNAL
+void                    g_action_muxer_remove                           (GActionMuxer *muxer,
+                                                                         const gchar  *prefix);
+
+G_END_DECLS
+
+#endif /* __G_ACTION_MUXER_H__ */

=== added file 'src/gactionobservable.c'
--- src/gactionobservable.c	1970-01-01 00:00:00 +0000
+++ src/gactionobservable.c	2012-03-18 15:43:27 +0000
@@ -0,0 +1,78 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * licence or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#include "config.h"
+
+#include "gactionobservable.h"
+
+G_DEFINE_INTERFACE (GActionObservable, g_action_observable, G_TYPE_OBJECT)
+
+/*
+ * SECTION:gactionobserable
+ * @short_description: an interface implemented by objects that report
+ *                     changes to actions
+ */
+
+void
+g_action_observable_default_init (GActionObservableInterface *iface)
+{
+}
+
+/*
+ * g_action_observable_register_observer:
+ * @observable: a #GActionObservable
+ * @action_name: the name of the action
+ * @observer: the #GActionObserver to which the events will be reported
+ *
+ * Registers @observer as being interested in changes to @action_name on
+ * @observable.
+ */
+void
+g_action_observable_register_observer (GActionObservable *observable,
+                                       const gchar       *action_name,
+                                       GActionObserver   *observer)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVABLE (observable));
+
+  G_ACTION_OBSERVABLE_GET_IFACE (observable)
+    ->register_observer (observable, action_name, observer);
+}
+
+/*
+ * g_action_observable_unregister_observer:
+ * @observable: a #GActionObservable
+ * @action_name: the name of the action
+ * @observer: the #GActionObserver to which the events will be reported
+ *
+ * Removes the registration of @observer as being interested in changes
+ * to @action_name on @observable.
+ *
+ * If the observer was registered multiple times, it must be
+ * unregistered an equal number of times.
+ */
+void
+g_action_observable_unregister_observer (GActionObservable *observable,
+                                         const gchar       *action_name,
+                                         GActionObserver   *observer)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVABLE (observable));
+
+  G_ACTION_OBSERVABLE_GET_IFACE (observable)
+    ->unregister_observer (observable, action_name, observer);
+}

=== added file 'src/gactionobservable.h'
--- src/gactionobservable.h	1970-01-01 00:00:00 +0000
+++ src/gactionobservable.h	2012-03-18 15:43:27 +0000
@@ -0,0 +1,62 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * licence or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#ifndef __G_ACTION_OBSERVABLE_H__
+#define __G_ACTION_OBSERVABLE_H__
+
+#include "gactionobserver.h"
+
+G_BEGIN_DECLS
+
+#define G_TYPE_ACTION_OBSERVABLE                            (g_action_observable_get_type ())
+#define G_ACTION_OBSERVABLE(inst)                           (G_TYPE_CHECK_INSTANCE_CAST ((inst),                     \
+                                                             G_TYPE_ACTION_OBSERVABLE, GActionObservable))
+#define G_IS_ACTION_OBSERVABLE(inst)                        (G_TYPE_CHECK_INSTANCE_TYPE ((inst),                     \
+                                                             G_TYPE_ACTION_OBSERVABLE))
+#define G_ACTION_OBSERVABLE_GET_IFACE(inst)                 (G_TYPE_INSTANCE_GET_INTERFACE ((inst),                  \
+                                                             G_TYPE_ACTION_OBSERVABLE, GActionObservableInterface))
+
+typedef struct _GActionObservableInterface                  GActionObservableInterface;
+
+struct _GActionObservableInterface
+{
+  GTypeInterface g_iface;
+
+  void (* register_observer)   (GActionObservable *observable,
+                                const gchar       *action_name,
+                                GActionObserver   *observer);
+  void (* unregister_observer) (GActionObservable *observable,
+                                const gchar       *action_name,
+                                GActionObserver   *observer);
+};
+
+G_GNUC_INTERNAL
+GType                   g_action_observable_get_type                    (void);
+G_GNUC_INTERNAL
+void                    g_action_observable_register_observer           (GActionObservable  *observable,
+                                                                         const gchar        *action_name,
+                                                                         GActionObserver    *observer);
+G_GNUC_INTERNAL
+void                    g_action_observable_unregister_observer         (GActionObservable  *observable,
+                                                                         const gchar        *action_name,
+                                                                         GActionObserver    *observer);
+
+G_END_DECLS
+
+#endif /* __G_ACTION_OBSERVABLE_H__ */

=== added file 'src/gactionobserver.c'
--- src/gactionobserver.c	1970-01-01 00:00:00 +0000
+++ src/gactionobserver.c	2012-03-18 15:43:27 +0000
@@ -0,0 +1,159 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * licence or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#include "config.h"
+
+#include "gactionobserver.h"
+
+G_DEFINE_INTERFACE (GActionObserver, g_action_observer, G_TYPE_OBJECT)
+
+/**
+ * SECTION:gactionobserver
+ * @short_description: an interface implemented by objects that are
+ *                     interested in monitoring actions for changes
+ *
+ * GActionObserver is a simple interface allowing objects that wish to
+ * be notified of changes to actions to be notified of those changes.
+ *
+ * It is also possible to monitor changes to action groups using
+ * #GObject signals, but there are a number of reasons that this
+ * approach could become problematic:
+ *
+ *  - there are four separate signals that must be manually connected
+ *    and disconnected
+ *
+ *  - when a large number of different observers wish to monitor a
+ *    (usually disjoint) set of actions within the same action group,
+ *    there is only one way to avoid having all notifications delivered
+ *    to all observers: signal detail.  In order to use signal detail,
+ *    each action name must be quarked, which is not always practical.
+ *
+ *  - even if quarking is acceptable, #GObject signal details are
+ *    implemented by scanning a linked list, so there is no real
+ *    decrease in complexity
+ */
+
+void
+g_action_observer_default_init (GActionObserverInterface *class)
+{
+}
+
+/*
+ * g_action_observer_action_added:
+ * @observer: a #GActionObserver
+ * @observable: the source of the event
+ * @action_name: the name of the action
+ * @enabled: %TRUE if the action is now enabled
+ * @parameter_type: the parameter type for action invocations, or %NULL
+ *                  if no parameter is required
+ * @state: the current state of the action, or %NULL if the action is
+ *         stateless
+ *
+ * This function is called when an action that the observer is
+ * registered to receive events for is added.
+ *
+ * This function should only be called by objects with which the
+ * observer has explicitly registered itself to receive events.
+ */
+void
+g_action_observer_action_added (GActionObserver    *observer,
+                                GActionObservable  *observable,
+                                const gchar        *action_name,
+                                const GVariantType *parameter_type,
+                                gboolean            enabled,
+                                GVariant           *state)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVER (observer));
+
+  G_ACTION_OBSERVER_GET_IFACE (observer)
+    ->action_added (observer, observable, action_name, parameter_type, enabled, state);
+}
+
+/*
+ * g_action_observer_action_enabled_changed:
+ * @observer: a #GActionObserver
+ * @observable: the source of the event
+ * @action_name: the name of the action
+ * @enabled: %TRUE if the action is now enabled
+ *
+ * This function is called when an action that the observer is
+ * registered to receive events for becomes enabled or disabled.
+ *
+ * This function should only be called by objects with which the
+ * observer has explicitly registered itself to receive events.
+ */
+void
+g_action_observer_action_enabled_changed (GActionObserver   *observer,
+                                          GActionObservable *observable,
+                                          const gchar       *action_name,
+                                          gboolean           enabled)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVER (observer));
+
+  G_ACTION_OBSERVER_GET_IFACE (observer)
+    ->action_enabled_changed (observer, observable, action_name, enabled);
+}
+
+/*
+ * g_action_observer_action_state_changed:
+ * @observer: a #GActionObserver
+ * @observable: the source of the event
+ * @action_name: the name of the action
+ * @state: the new state of the action
+ *
+ * This function is called when an action that the observer is
+ * registered to receive events for changes its state.
+ *
+ * This function should only be called by objects with which the
+ * observer has explicitly registered itself to receive events.
+ */
+void
+g_action_observer_action_state_changed (GActionObserver   *observer,
+                                        GActionObservable *observable,
+                                        const gchar       *action_name,
+                                        GVariant          *state)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVER (observer));
+
+  G_ACTION_OBSERVER_GET_IFACE (observer)
+    ->action_state_changed (observer, observable, action_name, state);
+}
+
+/*
+ * g_action_observer_action_removed:
+ * @observer: a #GActionObserver
+ * @observable: the source of the event
+ * @action_name: the name of the action
+ *
+ * This function is called when an action that the observer is
+ * registered to receive events for is removed.
+ *
+ * This function should only be called by objects with which the
+ * observer has explicitly registered itself to receive events.
+ */
+void
+g_action_observer_action_removed (GActionObserver   *observer,
+                                  GActionObservable *observable,
+                                  const gchar       *action_name)
+{
+  g_return_if_fail (G_IS_ACTION_OBSERVER (observer));
+
+  G_ACTION_OBSERVER_GET_IFACE (observer)
+    ->action_removed (observer, observable, action_name);
+}

=== added file 'src/gactionobserver.h'
--- src/gactionobserver.h	1970-01-01 00:00:00 +0000
+++ src/gactionobserver.h	2012-03-18 15:43:27 +0000
@@ -0,0 +1,88 @@
+/*
+ * Copyright © 2011 Canonical Limited
+ *
+ * This library is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * licence or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: Ryan Lortie <desrt@desrt.ca>
+ */
+
+#ifndef __G_ACTION_OBSERVER_H__
+#define __G_ACTION_OBSERVER_H__
+
+#include <gio/gio.h>
+
+G_BEGIN_DECLS
+
+#define G_TYPE_ACTION_OBSERVER                              (g_action_observer_get_type ())
+#define G_ACTION_OBSERVER(inst)                             (G_TYPE_CHECK_INSTANCE_CAST ((inst),                     \
+                                                             G_TYPE_ACTION_OBSERVER, GActionObserver))
+#define G_IS_ACTION_OBSERVER(inst)                          (G_TYPE_CHECK_INSTANCE_TYPE ((inst),                     \
+                                                             G_TYPE_ACTION_OBSERVER))
+#define G_ACTION_OBSERVER_GET_IFACE(inst)                   (G_TYPE_INSTANCE_GET_INTERFACE ((inst),                  \
+                                                             G_TYPE_ACTION_OBSERVER, GActionObserverInterface))
+
+typedef struct _GActionObserverInterface                    GActionObserverInterface;
+typedef struct _GActionObservable                           GActionObservable;
+typedef struct _GActionObserver                             GActionObserver;
+
+struct _GActionObserverInterface
+{
+  GTypeInterface g_iface;
+
+  void (* action_added)           (GActionObserver    *observer,
+                                   GActionObservable  *observable,
+                                   const gchar        *action_name,
+                                   const GVariantType *parameter_type,
+                                   gboolean            enabled,
+                                   GVariant           *state);
+  void (* action_enabled_changed) (GActionObserver    *observer,
+                                   GActionObservable  *observable,
+                                   const gchar        *action_name,
+                                   gboolean            enabled);
+  void (* action_state_changed)   (GActionObserver    *observer,
+                                   GActionObservable  *observable,
+                                   const gchar        *action_name,
+                                   GVariant           *state);
+  void (* action_removed)         (GActionObserver    *observer,
+                                   GActionObservable  *observable,
+                                   const gchar        *action_name);
+};
+
+G_GNUC_INTERNAL
+GType                   g_action_observer_get_type                      (void);
+G_GNUC_INTERNAL
+void                    g_action_observer_action_added                  (GActionObserver    *observer,
+                                                                         GActionObservable  *observable,
+                                                                         const gchar        *action_name,
+                                                                         const GVariantType *parameter_type,
+                                                                         gboolean            enabled,
+                                                                         GVariant           *state);
+G_GNUC_INTERNAL
+void                    g_action_observer_action_enabled_changed        (GActionObserver    *observer,
+                                                                         GActionObservable  *observable,
+                                                                         const gchar        *action_name,
+                                                                         gboolean            enabled);
+G_GNUC_INTERNAL
+void                    g_action_observer_action_state_changed          (GActionObserver    *observer,
+                                                                         GActionObservable  *observable,
+                                                                         const gchar        *action_name,
+                                                                         GVariant           *state);
+G_GNUC_INTERNAL
+void                    g_action_observer_action_removed                (GActionObserver    *observer,
+                                                                         GActionObservable  *observable,
+                                                                         const gchar        *action_name);
+
+G_END_DECLS
+
+#endif /* __G_ACTION_OBSERVER_H__ */

=== modified file 'src/hud-service.c'
--- src/hud-service.c	2012-03-07 21:55:41 +0000
+++ src/hud-service.c	2012-03-15 18:34:44 +0000
@@ -16,8 +16,12 @@
  * Author: Ryan Lortie <desrt@desrt.ca>
  */
 
+#include "config.h"
+
 #include <glib.h>
 #include <gio/gio.h>
+#include <locale.h>
+#include <libintl.h>
 
 #include "hudappindicatorsource.h"
 #include "hudindicatorsource.h"
@@ -132,6 +136,7 @@
         {
           g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS,
                                                  "item key has invalid format");
+          g_variant_unref (item_key);
           return;
         }
 
@@ -229,6 +234,10 @@
 
   g_type_init ();
 
+  setlocale (LC_ALL, "");
+  bindtextdomain (GETTEXT_PACKAGE, GNOMELOCALEDIR);
+  textdomain (GETTEXT_PACKAGE);
+
   hud_settings_init ();
 
   source_list = hud_source_list_new ();

=== modified file 'src/hudappindicatorsource.c'
--- src/hudappindicatorsource.c	2012-03-07 04:22:53 +0000
+++ src/hudappindicatorsource.c	2012-03-12 16:25:31 +0000
@@ -81,30 +81,30 @@
   const gchar *dbus_name;
   const gchar *dbus_path;
   GSequenceIter *iter;
+  const gchar *id;
   gint32 position;
   gchar *title;
 
   g_variant_get_child (description, 1, "i", &position);
   g_variant_get_child (description, 2, "&s", &dbus_name);
   g_variant_get_child (description, 3, "&o", &dbus_path);
+  g_variant_get_child (description, 8, "&s", &id);
   g_variant_get_child (description, 9, "s", &title);
 
   if (title[0] == '\0')
     {
-      const gchar *id;
-
       g_free (title);
       /* TRANSLATORS:  This is used for Application indicators that
          are not providing a title string.  The '%s' represents the
          unique ID that the app indicator provides, but it is usually
          the package name and not generally human readable.  An example
          for Network Manager would be 'nm-applet'. */
-      g_variant_get_child (description, 8, "&s", &id);
       title = g_strdup_printf(_("Untitled Indicator (%s)"), id);
     }
-  g_debug ("adding appindicator at %d ('%s', %s, %s)", position, title, dbus_name, dbus_path);
+  g_debug ("adding appindicator %s at %d ('%s', %s, %s)", id, position, title, dbus_name, dbus_path);
 
-  collector = hud_dbusmenu_collector_new_for_endpoint (title, hud_settings.indicator_penalty, dbus_name, dbus_path);
+  collector = hud_dbusmenu_collector_new_for_endpoint (id, title, hud_settings.indicator_penalty,
+                                                       dbus_name, dbus_path);
   g_signal_connect (collector, "changed", G_CALLBACK (hud_app_indicator_source_collector_changed), source);
 
   iter = g_sequence_get_iter_at_pos (source->indicators, position);

=== modified file 'src/huddbusmenucollector.c'
--- src/huddbusmenucollector.c	2012-03-07 04:11:28 +0000
+++ src/huddbusmenucollector.c	2012-03-13 14:33:02 +0000
@@ -208,10 +208,12 @@
 
   DbusmenuClient *client;
   DbusmenuMenuitem *root;
+  gchar *application_id;
   HudStringList *prefix;
   GHashTable *items;
   guint penalty;
   guint xid;
+  gboolean alive;
 };
 
 typedef GObjectClass HudDbusmenuCollectorClass;
@@ -299,7 +301,7 @@
   else
     context = collector->prefix;
 
-  item = hud_dbusmenu_item_new (context, NULL, menuitem);
+  item = hud_dbusmenu_item_new (context, collector->application_id, menuitem);
   g_hash_table_remove (collector->items, menuitem);
   g_hash_table_insert (collector->items, menuitem, item);
 
@@ -325,7 +327,8 @@
   for (child = dbusmenu_menuitem_get_children (menuitem); child; child = child->next)
     hud_dbusmenu_collector_add_item (collector, context, child->data);
 
-  hud_source_changed (HUD_SOURCE (collector));
+  if (collector->alive)
+    hud_source_changed (HUD_SOURCE (collector));
 }
 
 static void
@@ -342,7 +345,8 @@
   for (child = dbusmenu_menuitem_get_children (menuitem); child; child = child->next)
     hud_dbusmenu_collector_remove_item (collector, child->data);
 
-  hud_source_changed (HUD_SOURCE (collector));
+  if (collector->alive)
+    hud_source_changed (HUD_SOURCE (collector));
 }
 
 static void
@@ -377,7 +381,7 @@
                                        const gchar          *bus_name,
                                        const gchar          *object_path)
 {
-  g_debug ("endpoint is %s %s\n", bus_name, object_path);
+  g_debug ("endpoint is %s %s", bus_name, object_path);
 
   if (collector->client)
     {
@@ -389,7 +393,8 @@
   if (bus_name && object_path)
     {
       collector->client = dbusmenu_client_new (bus_name, object_path);
-      g_signal_connect (collector->client, "root-changed", G_CALLBACK (hud_dbusmenu_collector_root_changed), collector);
+      g_signal_connect_object (collector->client, "root-changed",
+                               G_CALLBACK (hud_dbusmenu_collector_root_changed), collector, 0);
       hud_dbusmenu_collector_setup_root (collector, dbusmenu_client_get_root (collector->client));
     }
 }
@@ -416,8 +421,15 @@
     hud_app_menu_registrar_remove_observer (hud_app_menu_registrar_get (), collector->xid,
                                             hud_dbusmenu_collector_registrar_observer_func, collector);
 
-  hud_string_list_unref (collector->prefix);
+  /* remove all the items without firing change signals */
+  collector->alive = FALSE;
+  hud_dbusmenu_collector_setup_endpoint (collector, NULL, NULL);
+
+  /* make sure the table is empty before we free it */
+  g_assert (g_hash_table_size (collector->items) == 0);
   g_hash_table_unref (collector->items);
+
+  hud_string_list_unref (collector->prefix);
   g_clear_object (&collector->client);
 
   G_OBJECT_CLASS (hud_dbusmenu_collector_parent_class)
@@ -467,7 +479,8 @@
  * Returns: a new #HudDbusmenuCollector
  **/
 HudDbusmenuCollector *
-hud_dbusmenu_collector_new_for_endpoint (const gchar *prefix,
+hud_dbusmenu_collector_new_for_endpoint (const gchar *application_id,
+                                         const gchar *prefix,
                                          guint        penalty,
                                          const gchar *bus_name,
                                          const gchar *object_path)
@@ -475,11 +488,14 @@
   HudDbusmenuCollector *collector;
 
   collector = g_object_new (HUD_TYPE_DBUSMENU_COLLECTOR, NULL);
+  collector->application_id = g_strdup (application_id);
   if (prefix)
     collector->prefix = hud_string_list_cons (prefix, NULL);
   collector->penalty = penalty;
   hud_dbusmenu_collector_setup_endpoint (collector, bus_name, object_path);
 
+  collector->alive = TRUE;
+
   return collector;
 }
 
@@ -495,16 +511,25 @@
  * Returns: a new #HudDbusmenuCollector
  **/
 HudDbusmenuCollector *
-hud_dbusmenu_collector_new_for_window (BamfWindow *window)
+hud_dbusmenu_collector_new_for_window (BamfWindow  *window,
+                                       const gchar *desktop_file)
 {
   HudDbusmenuCollector *collector;
+  BamfApplication *application;
 
   collector = g_object_new (HUD_TYPE_DBUSMENU_COLLECTOR, NULL);
+  collector->application_id = g_strdup (desktop_file);
   collector->xid = bamf_window_get_xid (window);
-  g_debug ("dbusmenu on %d\n", collector->xid);
+  g_debug ("dbusmenu on %d", collector->xid);
   hud_app_menu_registrar_add_observer (hud_app_menu_registrar_get (), collector->xid,
                                        hud_dbusmenu_collector_registrar_observer_func, collector);
 
+  application = bamf_matcher_get_application_for_window (bamf_matcher_get_default (), window);
+  if (application != NULL)
+    collector->application_id = g_strdup (bamf_application_get_desktop_file (application));
+
+  collector->alive = TRUE;
+
   return collector;
 }
 

=== modified file 'src/huddbusmenucollector.h'
--- src/huddbusmenucollector.h	2012-03-07 04:11:28 +0000
+++ src/huddbusmenucollector.h	2012-03-12 16:25:31 +0000
@@ -31,11 +31,13 @@
 
 GType                   hud_dbusmenu_collector_get_type                 (void);
 
-HudDbusmenuCollector *  hud_dbusmenu_collector_new_for_endpoint         (const gchar *prefix,
+HudDbusmenuCollector *  hud_dbusmenu_collector_new_for_endpoint         (const gchar *application_id,
+                                                                         const gchar *prefix,
                                                                          guint        penalty,
                                                                          const gchar *bus_name,
                                                                          const gchar *object_path);
-HudDbusmenuCollector *  hud_dbusmenu_collector_new_for_window           (BamfWindow  *window);
+HudDbusmenuCollector *  hud_dbusmenu_collector_new_for_window           (BamfWindow  *window,
+                                                                         const gchar *desktop_file);
 void                    hud_dbusmenu_collector_set_prefix               (HudDbusmenuCollector *collector,
                                                                          const gchar          *prefix);
 

=== modified file 'src/hudindicatorsource.c'
--- src/hudindicatorsource.c	2012-03-07 04:11:28 +0000
+++ src/hudindicatorsource.c	2012-03-12 16:25:31 +0000
@@ -147,7 +147,8 @@
   HudIndicatorSourceIndicator *indicator = user_data;
   HudDbusmenuCollector *collector;
 
-  collector = hud_dbusmenu_collector_new_for_endpoint (_(indicator->info->user_visible_name),
+  collector = hud_dbusmenu_collector_new_for_endpoint (indicator->info->indicator_name,
+                                                       _(indicator->info->user_visible_name),
                                                        hud_settings.indicator_penalty,
                                                        name_owner, indicator->info->dbus_menu_path);
   g_signal_connect (collector, "changed", G_CALLBACK (hud_indicator_source_collector_changed), indicator);

=== modified file 'src/huditem.c'
--- src/huditem.c	2012-03-07 21:55:41 +0000
+++ src/huditem.c	2012-03-13 13:32:36 +0000
@@ -53,6 +53,7 @@
   gchar *desktop_file;
 
   HudStringList *tokens;
+  gchar *usage_tag;
   gboolean enabled;
   guint usage;
   guint64 id;
@@ -91,6 +92,38 @@
   g_type_class_add_private (class, sizeof (HudItemPrivate));
 }
 
+static void
+hud_item_format_tokens (GString       *string,
+                        HudStringList *tokens)
+{
+  HudStringList *tail;
+
+  tail = hud_string_list_get_tail (tokens);
+
+  if (tail)
+    {
+      hud_item_format_tokens (string, tail);
+      g_string_append (string, "||");
+    }
+
+  g_string_append (string, hud_string_list_get_head (tokens));
+}
+
+static void
+hud_item_setup_usage (HudItem *item)
+{
+  GString *tag;
+
+  if (item->priv->tokens && item->priv->enabled)
+    {
+      tag = g_string_new (NULL);
+      hud_item_format_tokens (tag, item->priv->tokens);
+      item->priv->usage_tag = g_string_free (tag, FALSE);
+      item->priv->usage = usage_tracker_get_usage (usage_tracker_get_instance (),
+                                                   item->priv->desktop_file, item->priv->usage_tag);
+    }
+}
+
 /**
  * hud_item_construct:
  * @g_type: a #GType
@@ -121,7 +154,8 @@
 
   g_hash_table_insert (hud_item_table, &item->priv->id, item);
 
-  //item->usage = usage_tracker_get_usage (usage_tracker_get_instance (), desktop_file, identifier);
+  if (desktop_file)
+    hud_item_setup_usage (item);
 
   return item;
 }
@@ -167,8 +201,12 @@
   HUD_ITEM_GET_CLASS (item)
     ->activate (item, platform_data);
 
-  //usage_tracker_mark_usage (usage_tracker_get_instance (), item->desktop_file, item->identifier);
-  //item->usage = usage_tracker_get_usage (usage_tracker_get_instance (), item->desktop_file, item->identifier);
+  if (item->priv->usage_tag)
+    {
+      usage_tracker_mark_usage (usage_tracker_get_instance (), item->priv->desktop_file, item->priv->usage_tag);
+      item->priv->usage = usage_tracker_get_usage (usage_tracker_get_instance (),
+                                                   item->priv->desktop_file, item->priv->usage_tag);
+    }
 }
 
 /**

=== modified file 'src/hudmenumodelcollector.c'
--- src/hudmenumodelcollector.c	2012-03-07 04:22:53 +0000
+++ src/hudmenumodelcollector.c	2012-03-12 16:25:31 +0000
@@ -393,14 +393,18 @@
 /**
  * hud_menu_model_collector_get:
  * @window: a #BamfWindow
+ * @desktop_file: the desktop file of the application of @window
  *
  * If the given @window has #GMenuModel-style menus then returns a
  * collector for them, otherwise returns %NULL.
  *
+ * @desktop_file is used for usage tracking.
+ *
  * Returns: a #HudMenuModelCollector, or %NULL
  **/
 HudMenuModelCollector *
-hud_menu_model_collector_get (BamfWindow *window)
+hud_menu_model_collector_get (BamfWindow  *window,
+                              const gchar *desktop_file)
 {
   HudMenuModelCollector *collector;
   gchar *unique_bus_name;
@@ -443,6 +447,8 @@
   if (window_object_path)
     collector->window = g_dbus_action_group_get (session, unique_bus_name, window_object_path);
 
+  collector->desktop_file = g_strdup (desktop_file);
+
   /* when the action groups change, we could end up having items
    * enabled/disabled.  how to deal with that?
    */

=== modified file 'src/hudmenumodelcollector.h'
--- src/hudmenumodelcollector.h	2012-02-28 18:29:03 +0000
+++ src/hudmenumodelcollector.h	2012-03-12 16:25:31 +0000
@@ -32,6 +32,7 @@
 
 GType                   hud_menu_model_collector_get_type               (void);
 
-HudMenuModelCollector * hud_menu_model_collector_get                    (BamfWindow *window);
+HudMenuModelCollector * hud_menu_model_collector_get                    (BamfWindow  *window,
+                                                                         const gchar *desktop_file);
 
 #endif /* __HUD_MENU_MODEL_COLLECTOR_H__ */

=== modified file 'src/hudresult.c'
--- src/hudresult.c	2012-03-05 04:46:53 +0000
+++ src/hudresult.c	2012-03-12 16:27:09 +0000
@@ -18,6 +18,8 @@
 
 #include "hudresult.h"
 
+#include <string.h>
+
 #include "hudsettings.h"
 #include "distance.h"
 
@@ -138,6 +140,63 @@
     return NULL;
 }
 
+/* recurse so that we can avoid having to prepend the string */
+static void
+hud_result_format_tokens (GString       *string,
+                          HudStringList *tokens)
+{
+  HudStringList *tail;
+  gchar *escaped;
+
+  tail = hud_string_list_get_tail (tokens);
+
+  if (tail)
+    {
+      hud_result_format_tokens (string, tail);
+      g_string_append (string, " &gt; ");
+    }
+
+  escaped = g_markup_escape_text (hud_string_list_get_head (tokens), -1);
+  g_string_append (string, escaped);
+  g_free (escaped);
+}
+
+static void
+hud_result_format_description (HudResult *result)
+{
+  GString *description;
+  gint i;
+
+  description = g_string_new (NULL);
+  hud_result_format_tokens (description, hud_item_get_tokens (result->item));
+
+  for (i = 0; result->matched[i]; i++)
+    {
+      gchar *escaped;
+      gchar *match;
+
+      escaped = g_markup_escape_text (result->matched[i], -1);
+      match = strstr (description->str, escaped);
+
+      if (match != NULL)
+        {
+          gsize start, end;
+
+          start = match - description->str;
+          end = start + strlen (escaped);
+
+          /* modify the end first so that the modification to the start
+           * doesn't change the offset of the end */
+          g_string_insert (description, end, "</b>");
+          g_string_insert (description, start, "<b>");
+        }
+
+      g_free (escaped);
+    }
+
+  result->description = g_string_free (description, FALSE);
+}
+
 /**
  * hud_result_new:
  * @item: a #HudItem
@@ -165,7 +224,7 @@
   result = g_object_new (HUD_TYPE_RESULT, NULL);
   result->item = g_object_ref (item);
   result->distance = calculate_distance_from_list (search_string, hud_item_get_tokens (item), &result->matched);
-  result->description = hud_string_list_pretty_print (hud_item_get_tokens (result->item));
+  hud_result_format_description (result);
 
   result->distance += (result->distance * penalty) / 100;
 

=== modified file 'src/hudwindowsource.c'
--- src/hudwindowsource.c	2012-03-01 14:43:11 +0000
+++ src/hudwindowsource.c	2012-03-13 13:39:30 +0000
@@ -65,6 +65,8 @@
   BamfMatcher *matcher;
 
   BamfWindow *active_window;
+  BamfApplication *active_application;
+  const gchar *active_desktop_file;
 };
 
 typedef GObjectClass HudWindowSourceClass;
@@ -123,6 +125,10 @@
   window_name = bamf_view_get_name (BAMF_VIEW (window));
   g_debug ("checking window name '%s'", window_name);
 
+  /* sometimes bamf returns NULL here... protect ourselves */
+  if (window_name == NULL)
+    return TRUE;
+
   for (i = 0; i < G_N_ELEMENTS (ignored_names); i++)
     if (g_str_equal (ignored_names[i], window_name))
       {
@@ -136,38 +142,6 @@
   return ignored;
 }
 
-static gboolean
-hud_window_source_should_ignore_window (HudWindowSource *source,
-                                        BamfWindow      *window)
-{
-  BamfApplication *application;
-  const gchar *desktop_file;
-
-  application = bamf_matcher_get_application_for_window (source->matcher, window);
-
-  if (application == NULL)
-    {
-      g_debug ("ignoring window with no application");
-      return TRUE;
-    }
-
-  desktop_file = bamf_application_get_desktop_file (application);
-
-  if (desktop_file == NULL)
-    {
-      g_debug ("ignoring application with no desktop file");
-      return TRUE;
-    }
-
-  if (hud_window_source_desktop_file_in_debug_list (desktop_file))
-    return TRUE;
-
-  if (hud_window_source_name_in_ignore_list (window))
-    return TRUE;
-
-  return FALSE;
-}
-
 static HudSource *
 hud_window_source_get_collector (HudWindowSource *source)
 {
@@ -191,11 +165,12 @@
        * For that reason, we check first for GMenuModel and assume if it
        * doesn't exist then it must be dbusmenu.
        */
-      menumodel_collector = hud_menu_model_collector_get (source->active_window);
+      menumodel_collector = hud_menu_model_collector_get (source->active_window, source->active_desktop_file);
       if (menumodel_collector)
         collector = HUD_SOURCE (menumodel_collector);
       else
-        collector = HUD_SOURCE (hud_dbusmenu_collector_new_for_window (source->active_window));
+        collector = HUD_SOURCE (hud_dbusmenu_collector_new_for_window (source->active_window,
+                                                                       source->active_desktop_file));
 
       g_object_set_qdata_full (G_OBJECT (source->active_window), menu_collector_quark, collector, g_object_unref);
     }
@@ -221,6 +196,8 @@
   HudWindowSource *source = user_data;
   HudSource *collector;
   BamfWindow *window;
+  BamfApplication *application;
+  const gchar *desktop_file;
 
   g_debug ("Switching windows");
 
@@ -238,7 +215,26 @@
       return;
     }
 
-  if (hud_window_source_should_ignore_window (source, window))
+  if (hud_window_source_name_in_ignore_list (window))
+    return;
+
+  application = bamf_matcher_get_application_for_window (source->matcher, window);
+
+  if (application == NULL)
+    {
+      g_debug ("ignoring window with no application");
+      return;
+    }
+
+  desktop_file = bamf_application_get_desktop_file (application);
+
+  if (desktop_file == NULL)
+    {
+      g_debug ("ignoring application with no desktop file");
+      return;
+    }
+
+  if (hud_window_source_desktop_file_in_debug_list (desktop_file))
     return;
 
   g_debug ("new active window (xid %u)", bamf_window_get_xid (window));
@@ -247,8 +243,11 @@
   if (collector)
     g_signal_handlers_disconnect_by_func (collector, hud_window_source_collector_changed, source);
 
+  g_clear_object (&source->active_application);
   g_clear_object (&source->active_window);
   source->active_window = g_object_ref (window);
+  source->active_application = g_object_ref (application);
+  source->active_desktop_file = desktop_file;
 
   collector = hud_window_source_get_collector (source);
   g_signal_connect_object (collector, "changed", G_CALLBACK (hud_window_source_collector_changed), source, 0);
@@ -276,6 +275,7 @@
   HudWindowSource *source = HUD_WINDOW_SOURCE (object);
 
   /* bamf matcher signals already disconnected in dispose */
+  g_clear_object (&source->active_application);
   g_clear_object (&source->active_window);
 
   G_OBJECT_CLASS (hud_window_source_parent_class)

=== modified file 'src/indicator-appmenu.c'
--- src/indicator-appmenu.c	2012-03-07 21:22:18 +0000
+++ src/indicator-appmenu.c	2012-03-18 18:58:06 +0000
@@ -38,7 +38,9 @@
 #include "gen-application-menu-registrar.xml.h"
 #include "gen-application-menu-renderer.xml.h"
 #include "indicator-appmenu-marshal.h"
-#include "window-menus.h"
+#include "window-menu.h"
+#include "window-menu-dbusmenu.h"
+#include "window-menu-model.h"
 #include "dbus-shared.h"
 #include "gdk-get-func.h"
 
@@ -81,7 +83,7 @@
 
 	gulong retry_registration;
 
-	WindowMenus * default_app;
+	WindowMenu * default_app;
 	GHashTable * apps;
 
 	BamfMatcher * matcher;
@@ -99,7 +101,7 @@
 	GArray * window_menus;
 
 	GHashTable * desktop_windows;
-	WindowMenus * desktop_menu;
+	WindowMenu * desktop_menu;
 
 	GDBusConnection * bus;
 	guint owner_id;
@@ -151,7 +153,7 @@
                                                                       guint windowid,
                                                                       guint timestamp);
 static void switch_default_app                                       (IndicatorAppmenu * iapp,
-                                                                      WindowMenus * newdef,
+                                                                      WindowMenu * newdef,
                                                                       BamfWindow * active_window);
 static void find_desktop_windows                                     (IndicatorAppmenu * iapp);
 static void new_window                                               (BamfMatcher * matcher,
@@ -160,20 +162,20 @@
 static void old_window                                               (BamfMatcher * matcher,
                                                                       BamfView * view,
                                                                       gpointer user_data);
-static void window_entry_added                                       (WindowMenus * mw,
-                                                                      IndicatorObjectEntry * entry,
-                                                                      gpointer user_data);
-static void window_entry_removed                                     (WindowMenus * mw,
-                                                                      IndicatorObjectEntry * entry,
-                                                                      gpointer user_data);
-static void window_status_changed                                    (WindowMenus * mw,
+static void window_entry_added                                       (WindowMenu * mw,
+                                                                      IndicatorObjectEntry * entry,
+                                                                      gpointer user_data);
+static void window_entry_removed                                     (WindowMenu * mw,
+                                                                      IndicatorObjectEntry * entry,
+                                                                      gpointer user_data);
+static void window_status_changed                                    (WindowMenu * mw,
                                                                       DbusmenuStatus status,
                                                                       IndicatorAppmenu * iapp);
-static void window_show_menu                                         (WindowMenus * mw,
+static void window_show_menu                                         (WindowMenu * mw,
                                                                       IndicatorObjectEntry * entry,
                                                                       guint timestamp,
                                                                       gpointer user_data);
-static void window_a11y_update                                       (WindowMenus * mw,
+static void window_a11y_update                                       (WindowMenu * mw,
                                                                       IndicatorObjectEntry * entry,
                                                                       gpointer user_data);
 static void active_window_changed                                    (BamfMatcher * matcher,
@@ -589,7 +591,7 @@
 		gpointer pwm = g_hash_table_lookup(iapp->apps, GUINT_TO_POINTER(xid));
 		if (pwm != NULL) {
 			g_debug("Setting Desktop Menus to: %X", xid);
-			iapp->desktop_menu = WINDOW_MENUS(pwm);
+			iapp->desktop_menu = WINDOW_MENU(pwm);
 		}
 	}
 
@@ -642,7 +644,7 @@
 
 	gpointer pwm = g_hash_table_lookup(iapp->apps, GUINT_TO_POINTER(xid));
 	if (pwm != NULL) {
-		WindowMenus * wm = WINDOW_MENUS(pwm);
+		WindowMenu * wm = WINDOW_MENU(pwm);
 		iapp->desktop_menu = wm;
 		g_debug("Setting Desktop Menus to: %X", xid);
 		if (iapp->active_window == NULL && iapp->default_app == NULL) {
@@ -756,7 +758,7 @@
 
 	/* If we have a focused app with menus, use it's windows */
 	if (iapp->default_app != NULL) {
-		return window_menus_get_entries(iapp->default_app);
+		return window_menu_get_entries(iapp->default_app);
 	}
 
 	/* Else, let's go with desktop windows if there isn't a focused window */
@@ -764,7 +766,7 @@
 		if (iapp->desktop_menu == NULL) {
 			return NULL;
 		} else {
-			return window_menus_get_entries(iapp->desktop_menu);
+			return window_menu_get_entries(iapp->desktop_menu);
 		}
 	}
 
@@ -814,7 +816,7 @@
 	IndicatorAppmenu * iapp = INDICATOR_APPMENU(io);
 	if (iapp->default_app != NULL) {
 		/* Find the location in the app */
-		count = window_menus_get_location(iapp->default_app, entry);
+		count = window_menu_get_location(iapp->default_app, entry);
 	} else if (iapp->active_window != NULL) {
 		/* Find the location in the window menus */
 		for (count = 0; count < iapp->window_menus->len; count++) {
@@ -829,7 +831,7 @@
 	} else {
 		/* Find the location in the desktop menu */
 		if (iapp->desktop_menu != NULL) {
-			count = window_menus_get_location(iapp->desktop_menu, entry);
+			count = window_menu_get_location(iapp->desktop_menu, entry);
 		}
 	}
 	return count;
@@ -842,6 +844,32 @@
 	return entry_activate_window(io, entry, 0, timestamp);
 }
 
+/* Find the BAMF Window that is associated with that XID.  Unfortunately
+   this requires a bit of searching, don't do it too often */
+static BamfWindow *
+xid_to_bamf_window (IndicatorAppmenu * iapp, guint xid)
+{
+	GList * windows = bamf_matcher_get_windows(iapp->matcher);
+	GList * window;
+	BamfWindow * newwindow = NULL;
+
+	for (window = windows; window != NULL; window = g_list_next(window)) {
+		if (!BAMF_IS_WINDOW(window->data)) {
+			continue;
+		}
+
+		BamfWindow * testwindow = BAMF_WINDOW(window->data);
+
+		if (xid == bamf_window_get_xid(testwindow)) {
+			newwindow = testwindow;
+			break;
+		}
+	}
+	g_list_free(windows);
+
+	return newwindow;
+}
+
 /* Responds to a menuitem being activated on the panel. */
 static void
 entry_activate_window (IndicatorObject * io, IndicatorObjectEntry * entry, guint windowid, guint timestamp)
@@ -851,23 +879,7 @@
 	/* We need to force a focus change in this case as we probably
 	   just haven't gotten the signal from BAMF yet */
 	if (windowid != 0) {
-		GList * windows = bamf_matcher_get_windows(iapp->matcher);
-		GList * window;
-		BamfView * newwindow = NULL;
-
-		for (window = windows; window != NULL; window = g_list_next(window)) {
-			if (!BAMF_IS_WINDOW(window->data)) {
-				continue;
-			}
-
-			BamfWindow * testwindow = BAMF_WINDOW(window->data);
-
-			if (windowid == bamf_window_get_xid(testwindow)) {
-				newwindow = BAMF_VIEW(testwindow);
-				break;
-			}
-		}
-		g_list_free(windows);
+		BamfView * newwindow = BAMF_VIEW(xid_to_bamf_window(iapp, windowid));
 
 		if (newwindow != NULL) {
 			active_window_changed(iapp->matcher, BAMF_VIEW(iapp->active_window), newwindow, iapp);
@@ -875,13 +887,13 @@
 	}
 
 	if (iapp->default_app != NULL) {
-		window_menus_entry_activate(iapp->default_app, entry, timestamp);
+		window_menu_entry_activate(iapp->default_app, entry, timestamp);
 		return;
 	}
 
 	if (iapp->active_window == NULL) {
 		if (iapp->desktop_menu != NULL) {
-			window_menus_entry_activate(iapp->desktop_menu, entry, timestamp);
+			window_menu_entry_activate(iapp->desktop_menu, entry, timestamp);
 		}
 		return;
 	}
@@ -969,7 +981,7 @@
 /* Switch applications, remove all the entires for the previous
    one and add them for the new application */
 static void
-switch_default_app (IndicatorAppmenu * iapp, WindowMenus * newdef, BamfWindow * active_window)
+switch_default_app (IndicatorAppmenu * iapp, WindowMenu * newdef, BamfWindow * active_window)
 {
 	if (iapp->default_app == newdef && iapp->default_app != NULL) {
 		/* We've got an app with menus and it hasn't changed. */
@@ -1024,23 +1036,23 @@
 
 		/* Connect signals */
 		iapp->sig_entry_added =   g_signal_connect(G_OBJECT(iapp->default_app),
-		                                           WINDOW_MENUS_SIGNAL_ENTRY_ADDED,
+		                                           WINDOW_MENU_SIGNAL_ENTRY_ADDED,
 		                                           G_CALLBACK(window_entry_added),
 		                                           iapp);
 		iapp->sig_entry_removed = g_signal_connect(G_OBJECT(iapp->default_app),
-		                                           WINDOW_MENUS_SIGNAL_ENTRY_REMOVED,
+		                                           WINDOW_MENU_SIGNAL_ENTRY_REMOVED,
 		                                           G_CALLBACK(window_entry_removed),
 		                                           iapp);
 		iapp->sig_status_changed = g_signal_connect(G_OBJECT(iapp->default_app),
-		                                           WINDOW_MENUS_SIGNAL_STATUS_CHANGED,
+		                                           WINDOW_MENU_SIGNAL_STATUS_CHANGED,
 		                                           G_CALLBACK(window_status_changed),
 		                                           iapp);
 		iapp->sig_show_menu     = g_signal_connect(G_OBJECT(iapp->default_app),
-		                                           WINDOW_MENUS_SIGNAL_SHOW_MENU,
+		                                           WINDOW_MENU_SIGNAL_SHOW_MENU,
 		                                           G_CALLBACK(window_show_menu),
 		                                           iapp);
 		iapp->sig_a11y_update   = g_signal_connect(G_OBJECT(iapp->default_app),
-		                                           WINDOW_MENUS_SIGNAL_A11Y_UPDATE,
+		                                           WINDOW_MENU_SIGNAL_A11Y_UPDATE,
 		                                           G_CALLBACK(window_a11y_update),
 		                                           iapp);
 	}
@@ -1048,11 +1060,11 @@
 	/* show the entries that we're swapping in */
 	indicator_object_set_visible (INDICATOR_OBJECT(iapp), TRUE);
 
-		/* Set up initial state for new entries if needed */
+	/* Set up initial state for new entries if needed */
 	if (iapp->default_app != NULL &&
-            window_menus_get_status (iapp->default_app) != DBUSMENU_STATUS_NORMAL) {
+            window_menu_get_status (iapp->default_app) != WINDOW_MENU_STATUS_NORMAL) {
 		window_status_changed (iapp->default_app,
-		                       window_menus_get_status (iapp->default_app),
+		                       window_menu_get_status (iapp->default_app),
 		                       iapp);
 	}
 
@@ -1083,7 +1095,7 @@
 		return;
 	}
 
-	WindowMenus * menus = NULL;
+	WindowMenu * menus = NULL;
 	guint32 xid = 0;
 
 	while (window != NULL && menus == NULL) {
@@ -1091,6 +1103,20 @@
 	
 		menus = g_hash_table_lookup(appmenu->apps, GUINT_TO_POINTER(xid));
 
+		/* First look to see if we can get these from the
+		   GMenuModel access */
+		if (menus == NULL) {
+			gchar * uniquename = bamf_window_get_utf8_prop (window, "_GTK_UNIQUE_BUS_NAME");
+
+			if (uniquename != NULL) {
+				menus = WINDOW_MENU(window_menu_model_new(/* TODO */ NULL, window));
+
+				g_hash_table_insert(appmenu->apps, GUINT_TO_POINTER(xid), menus);
+			}
+
+			g_free(uniquename);
+		}
+
 		if (menus == NULL) {
 			g_debug("Looking for parent window on XID %d", xid);
 			window = bamf_window_get_transient(window);
@@ -1116,10 +1142,10 @@
 menus_destroyed (GObject * menus, gpointer user_data)
 {
 	gboolean reload_menus = FALSE;
-	WindowMenus * wm = WINDOW_MENUS(menus);
+	WindowMenu * wm = WINDOW_MENU(menus);
 	IndicatorAppmenu * iapp = INDICATOR_APPMENU(user_data);
 
-	guint32 xid = window_menus_get_xid(wm);
+	guint32 xid = window_menu_get_xid(wm);
 	g_return_if_fail(xid != 0);
 
 	g_hash_table_steal(iapp->apps, GUINT_TO_POINTER(xid));
@@ -1158,7 +1184,7 @@
 	g_hash_table_remove(iapp->destruction_timers, GUINT_TO_POINTER(windowid));
 
 	if (g_hash_table_lookup(iapp->apps, GUINT_TO_POINTER(windowid)) == NULL && windowid != 0) {
-		WindowMenus * wm = window_menus_new(windowid, sender, objectpath);
+		WindowMenu * wm = WINDOW_MENU(window_menu_dbusmenu_new(windowid, sender, objectpath));
 		g_return_val_if_fail(wm != NULL, FALSE);
 
 		g_hash_table_insert(iapp->apps, GUINT_TO_POINTER(windowid), wm);
@@ -1233,12 +1259,12 @@
 static GVariant *
 get_menu_for_window (IndicatorAppmenu * iapp, guint windowid, GError ** error)
 {
-	WindowMenus * wm = NULL;
+	WindowMenu * wm = NULL;
 
 	if (windowid == 0) {
 		wm = iapp->default_app;
 	} else {
-		wm = WINDOW_MENUS(g_hash_table_lookup(iapp->apps, GUINT_TO_POINTER(windowid)));
+		wm = WINDOW_MENU(g_hash_table_lookup(iapp->apps, GUINT_TO_POINTER(windowid)));
 	}
 
 	if (wm == NULL) {
@@ -1246,8 +1272,18 @@
 		return NULL;
 	}
 
-	return g_variant_new("(so)", window_menus_get_address(wm),
-	                     window_menus_get_path(wm));
+	GVariantBuilder builder;
+	g_variant_builder_init(&builder, G_VARIANT_TYPE_TUPLE);
+
+	if (IS_WINDOW_MENU_DBUSMENU(wm)) {
+		g_variant_builder_add_value(&builder, g_variant_new_string(window_menu_dbusmenu_get_address(WINDOW_MENU_DBUSMENU(wm))));
+		g_variant_builder_add_value(&builder, g_variant_new_object_path(window_menu_dbusmenu_get_path(WINDOW_MENU_DBUSMENU(wm))));
+	} else {
+		g_variant_builder_add_value(&builder, g_variant_new_string(""));
+		g_variant_builder_add_value(&builder, g_variant_new_object_path("/"));
+	}
+
+	return g_variant_builder_end(&builder);
 }
 
 /* Get all the menus we have */
@@ -1269,9 +1305,15 @@
 
 		GVariantBuilder tuple;
 		g_variant_builder_init(&tuple, G_VARIANT_TYPE_TUPLE);
-		g_variant_builder_add_value(&tuple, g_variant_new_uint32(window_menus_get_xid(WINDOW_MENUS(hash_val))));
-		g_variant_builder_add_value(&tuple, g_variant_new_string(window_menus_get_address(WINDOW_MENUS(hash_val))));
-		g_variant_builder_add_value(&tuple, g_variant_new_object_path(window_menus_get_path(WINDOW_MENUS(hash_val))));
+		g_variant_builder_add_value(&tuple, g_variant_new_uint32(window_menu_get_xid(WINDOW_MENU(hash_val))));
+
+		if (IS_WINDOW_MENU_DBUSMENU(hash_val)) {
+			g_variant_builder_add_value(&tuple, g_variant_new_string(window_menu_dbusmenu_get_address(WINDOW_MENU_DBUSMENU(hash_val))));
+			g_variant_builder_add_value(&tuple, g_variant_new_object_path(window_menu_dbusmenu_get_path(WINDOW_MENU_DBUSMENU(hash_val))));
+		} else {
+			g_variant_builder_add_value(&tuple, g_variant_new_string(""));
+			g_variant_builder_add_value(&tuple, g_variant_new_object_path("/"));
+		}
 
 		g_variant_builder_add_value(&array, g_variant_builder_end(&tuple));
 	}
@@ -1324,7 +1366,7 @@
 
 /* Pass up the entry added event */
 static void
-window_entry_added (WindowMenus * mw, IndicatorObjectEntry * entry, gpointer user_data)
+window_entry_added (WindowMenu * mw, IndicatorObjectEntry * entry, gpointer user_data)
 {
 	g_signal_emit_by_name(G_OBJECT(user_data), INDICATOR_OBJECT_SIGNAL_ENTRY_ADDED, entry);
 	return;
@@ -1332,7 +1374,7 @@
 
 /* Pass up the entry removed event */
 static void
-window_entry_removed (WindowMenus * mw, IndicatorObjectEntry * entry, gpointer user_data)
+window_entry_removed (WindowMenu * mw, IndicatorObjectEntry * entry, gpointer user_data)
 {
 	g_signal_emit_by_name(G_OBJECT(user_data), INDICATOR_OBJECT_SIGNAL_ENTRY_REMOVED, entry);
 	return;
@@ -1340,7 +1382,7 @@
 
 /* Pass up the status changed event */
 static void
-window_status_changed (WindowMenus * mw, DbusmenuStatus status, IndicatorAppmenu * iapp)
+window_status_changed (WindowMenu * mw, DbusmenuStatus status, IndicatorAppmenu * iapp)
 {
 	gboolean show_now = (status == DBUSMENU_STATUS_NOTICE);
 	GList * entry_head, * entries;
@@ -1357,7 +1399,7 @@
 
 /* Pass up the show menu event */
 static void
-window_show_menu (WindowMenus * mw, IndicatorObjectEntry * entry, guint timestamp, gpointer user_data)
+window_show_menu (WindowMenu * mw, IndicatorObjectEntry * entry, guint timestamp, gpointer user_data)
 {
 	g_signal_emit_by_name(G_OBJECT(user_data), INDICATOR_OBJECT_SIGNAL_MENU_SHOW, entry, timestamp);
 	return;
@@ -1365,7 +1407,7 @@
 
 /* Pass up the accessible string update */
 static void
-window_a11y_update (WindowMenus * mw, IndicatorObjectEntry * entry, gpointer user_data)
+window_a11y_update (WindowMenu * mw, IndicatorObjectEntry * entry, gpointer user_data)
 {
 	g_signal_emit_by_name(G_OBJECT(user_data), INDICATOR_OBJECT_SIGNAL_ACCESSIBLE_DESC_UPDATE, entry);
 	return;

=== modified file 'src/usage-tracker.c'
--- src/usage-tracker.c	2012-03-05 19:20:05 +0000
+++ src/usage-tracker.c	2012-03-12 16:15:18 +0000
@@ -20,6 +20,8 @@
 with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
+#define G_LOG_DOMAIN "usagetracker"
+
 #ifdef HAVE_CONFIG_H
 #include "config.h"
 #endif
@@ -340,6 +342,8 @@
 	g_return_if_fail(IS_USAGE_TRACKER(self));
 	g_return_if_fail(self->priv->db != NULL);
 
+	g_debug ("Marking %s %s", application, entry);
+
 	check_app_init(self, application);
 
 	sqlite3_reset(self->priv->insert_entry);
@@ -404,6 +408,8 @@
 		g_warning("Unknown status from executing entry_count: %d", exec_status);
 	}
 
+	g_debug ("Usage of %s %s is %u", application, entry, count);
+
 	return count;
 }
 

=== renamed file 'src/window-menus.c' => 'src/window-menu-dbusmenu.c'
--- src/window-menus.c	2012-02-03 14:08:48 +0000
+++ src/window-menu-dbusmenu.c	2012-03-18 18:58:06 +0000
@@ -29,13 +29,13 @@
 #include <glib.h>
 #include <gio/gio.h>
 
-#include "window-menus.h"
+#include "window-menu-dbusmenu.h"
 #include "indicator-appmenu-marshal.h"
 
 /* Private parts */
 
-typedef struct _WindowMenusPrivate WindowMenusPrivate;
-struct _WindowMenusPrivate {
+typedef struct _WindowMenuDbusmenuPrivate WindowMenuDbusmenuPrivate;
+struct _WindowMenuDbusmenuPrivate {
 	guint windowid;
 	DbusmenuGtkClient * client;
 	DbusmenuMenuitem * root;
@@ -52,29 +52,15 @@
 	gboolean disabled;
 	gboolean hidden;
 	DbusmenuMenuitem * mi;
-	WindowMenus * wm;
-};
-
-#define WINDOW_MENUS_GET_PRIVATE(o) \
-(G_TYPE_INSTANCE_GET_PRIVATE ((o), WINDOW_MENUS_TYPE, WindowMenusPrivate))
-
-/* Signals */
-
-enum {
-	ENTRY_ADDED,
-	ENTRY_REMOVED,
-	ERROR_STATE,
-	STATUS_CHANGED,
-	SHOW_MENU,
-	A11Y_UPDATE,
-	LAST_SIGNAL
-};
-
-static guint signals[LAST_SIGNAL] = { 0 };
+	WindowMenuDbusmenu * wm;
+};
+
+#define WINDOW_MENU_DBUSMENU_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), WINDOW_MENU_DBUSMENU_TYPE, WindowMenuDbusmenuPrivate))
 
 /* Prototypes */
 
-static void window_menus_dispose    (GObject *object);
+static void window_menu_dbusmenu_dispose    (GObject *object);
 static void root_changed            (DbusmenuClient * client, DbusmenuMenuitem * new_root, gpointer user_data);
 static void event_status            (DbusmenuClient * client, DbusmenuMenuitem * mi, gchar * event, GVariant * evdata, guint timestamp, GError * error, gpointer user_data);
 static void item_activate           (DbusmenuClient * client, DbusmenuMenuitem * item, guint timestamp, gpointer user_data);
@@ -86,71 +72,43 @@
 static void menu_prop_changed       (DbusmenuMenuitem * item, const gchar * property, GVariant * value, gpointer user_data);
 static void menu_child_realized     (DbusmenuMenuitem * child, gpointer user_data);
 static void props_cb (GObject * object, GAsyncResult * res, gpointer user_data);
+static GList *          get_entries      (WindowMenu * wm);
+static guint            get_location     (WindowMenu * wm, IndicatorObjectEntry * entry);
+static guint            get_xid          (WindowMenu * wm);
+static gboolean         get_error_state  (WindowMenu * wm);
+static WindowMenuStatus get_status       (WindowMenu * wm);
+static void             entry_restore    (WindowMenu * wm, IndicatorObjectEntry * entry);
+static void             entry_activate   (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp);
 
-G_DEFINE_TYPE (WindowMenus, window_menus, G_TYPE_OBJECT);
+G_DEFINE_TYPE (WindowMenuDbusmenu, window_menu_dbusmenu, WINDOW_MENU_TYPE);
 
 /* Build the one-time class */
 static void
-window_menus_class_init (WindowMenusClass *klass)
+window_menu_dbusmenu_class_init (WindowMenuDbusmenuClass *klass)
 {
 	GObjectClass *object_class = G_OBJECT_CLASS (klass);
 
-	g_type_class_add_private (klass, sizeof (WindowMenusPrivate));
-
-	object_class->dispose = window_menus_dispose;
-
-	/* Signals */
-	signals[ENTRY_ADDED] =  g_signal_new(WINDOW_MENUS_SIGNAL_ENTRY_ADDED,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, entry_added),
-	                                      NULL, NULL,
-	                                      g_cclosure_marshal_VOID__POINTER,
-	                                      G_TYPE_NONE, 1, G_TYPE_POINTER);
-	signals[ENTRY_REMOVED] =  g_signal_new(WINDOW_MENUS_SIGNAL_ENTRY_REMOVED,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, entry_removed),
-	                                      NULL, NULL,
-	                                      g_cclosure_marshal_VOID__POINTER,
-	                                      G_TYPE_NONE, 1, G_TYPE_POINTER);
-	signals[ERROR_STATE] =   g_signal_new(WINDOW_MENUS_SIGNAL_ERROR_STATE,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, error_state),
-	                                      NULL, NULL,
-	                                      g_cclosure_marshal_VOID__BOOLEAN,
-	                                      G_TYPE_NONE, 1, G_TYPE_BOOLEAN, G_TYPE_NONE);
-	signals[STATUS_CHANGED] = g_signal_new(WINDOW_MENUS_SIGNAL_STATUS_CHANGED,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, status_changed),
-	                                      NULL, NULL,
-	                                      g_cclosure_marshal_VOID__INT,
-	                                      G_TYPE_NONE, 1, G_TYPE_INT, G_TYPE_NONE);
-	signals[SHOW_MENU] =     g_signal_new(WINDOW_MENUS_SIGNAL_SHOW_MENU,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, show_menu),
-	                                      NULL, NULL,
-	                                      _indicator_appmenu_marshal_VOID__POINTER_UINT,
-	                                      G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_UINT, G_TYPE_NONE);
-	signals[A11Y_UPDATE] =   g_signal_new(WINDOW_MENUS_SIGNAL_A11Y_UPDATE,
-	                                      G_TYPE_FROM_CLASS(klass),
-	                                      G_SIGNAL_RUN_LAST,
-	                                      G_STRUCT_OFFSET (WindowMenusClass, a11y_update),
-	                                      NULL, NULL,
-	                                      _indicator_appmenu_marshal_VOID__POINTER,
-	                                      G_TYPE_NONE, 1, G_TYPE_POINTER, G_TYPE_NONE);
+	g_type_class_add_private (klass, sizeof (WindowMenuDbusmenuPrivate));
+
+	object_class->dispose = window_menu_dbusmenu_dispose;
+
+	WindowMenuClass * menu_class = WINDOW_MENU_CLASS(klass);
+	menu_class->get_entries = get_entries;
+	menu_class->get_location = get_location;
+	menu_class->get_xid = get_xid;
+	menu_class->get_error_state = get_error_state;
+	menu_class->get_status = get_status;
+	menu_class->entry_restore = entry_restore;
+	menu_class->entry_activate = entry_activate;
 
 	return;
 }
 
 /* Initialize the per-instance data */
 static void
-window_menus_init (WindowMenus *self)
+window_menu_dbusmenu_init (WindowMenuDbusmenu *self)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(self);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(self);
 
 	priv->client = NULL;
 	priv->props_cancel = NULL;
@@ -198,9 +156,9 @@
 static void
 free_entries(GObject *object, gboolean should_signal)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(object));
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(object));
 
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(object);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(object);
 
 	if (priv->entries != NULL) {
 		while (priv->entries->len > 0) {
@@ -208,7 +166,7 @@
 			entry = g_array_index(priv->entries, IndicatorObjectEntry *, 0);
 			g_array_remove_index(priv->entries, 0);
 			if (should_signal) {			
-				g_signal_emit(object, signals[ENTRY_REMOVED], 0, entry, TRUE);
+				g_signal_emit_by_name(object, WINDOW_MENU_SIGNAL_ENTRY_REMOVED, entry, TRUE);
 			}
 			entry_free(entry);
 		}
@@ -217,9 +175,9 @@
 
 /* Destroy objects */
 static void
-window_menus_dispose (GObject *object)
+window_menu_dbusmenu_dispose (GObject *object)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(object);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(object);
 
 	free_entries(object, FALSE);
 
@@ -259,7 +217,7 @@
 		priv->retry_timer = 0;
 	}
 
-	G_OBJECT_CLASS (window_menus_parent_class)->dispose (object);
+	G_OBJECT_CLASS (window_menu_dbusmenu_parent_class)->dispose (object);
 	return;
 }
 
@@ -269,8 +227,8 @@
 retry_event (gpointer user_data)
 {
 	g_debug("Retrying event");
-	g_return_val_if_fail(IS_WINDOW_MENUS(user_data), FALSE);
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data), FALSE);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	dbusmenu_menuitem_handle_event(dbusmenu_client_get_root(DBUSMENU_CLIENT(priv->client)),
 	                               "x-appmenu-retry-ping",
@@ -286,8 +244,8 @@
 static void
 event_status (DbusmenuClient * client, DbusmenuMenuitem * mi, gchar * event, GVariant * evdata, guint timestamp, GError * error, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	/* We don't care about status where there are no errors
 	   when we're in a happy state, just let them go. */
@@ -300,11 +258,11 @@
 	if (error == NULL) {
 		g_debug("Error state repaired");
 		priv->error_state = FALSE;
-		g_signal_emit(G_OBJECT(user_data), signals[ERROR_STATE], 0, priv->error_state, TRUE);
+		g_signal_emit_by_name(G_OBJECT(user_data), WINDOW_MENU_SIGNAL_ERROR_STATE, priv->error_state, TRUE);
 
 		for (i = 0; i < priv->entries->len; i++) {
 			IndicatorObjectEntry * entry = g_array_index(priv->entries, IndicatorObjectEntry *, i);
-			window_menus_entry_restore(WINDOW_MENUS(user_data), entry);
+			entry_restore(WINDOW_MENU(user_data), entry);
 		}
 
 		if (priv->retry_timer != 0) {
@@ -318,7 +276,7 @@
 	/* Uhg, means that events are breaking, now we need to
 	   try and handle that case. */
 	priv->error_state = TRUE;
-	g_signal_emit(G_OBJECT(user_data), signals[ERROR_STATE], 0, priv->error_state, TRUE);
+	g_signal_emit_by_name(G_OBJECT(user_data), WINDOW_MENU_SIGNAL_ERROR_STATE, priv->error_state, TRUE);
 
 	for (i = 0; i < priv->entries->len; i++) {
 		IndicatorObjectEntry * entry = g_array_index(priv->entries, IndicatorObjectEntry *, i);
@@ -340,9 +298,9 @@
 }
 
 static IndicatorObjectEntry *
-get_entry(WindowMenus *wm, DbusmenuMenuitem * item, guint *index)
+get_entry(WindowMenuDbusmenu *wm, DbusmenuMenuitem * item, guint *index)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 
 	guint position = 0;
 	for (position = 0; position < priv->entries->len; ++position) {
@@ -364,20 +322,20 @@
 static void
 item_activate (DbusmenuClient * client, DbusmenuMenuitem * item, guint timestamp, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	if (priv->root == NULL) {
 		return;
 	}
 
-	IndicatorObjectEntry * entry = get_entry(WINDOW_MENUS(user_data), item, NULL);
+	IndicatorObjectEntry * entry = get_entry(WINDOW_MENU_DBUSMENU(user_data), item, NULL);
 	if (entry == NULL) {
 		/* Not found */
 		return;
 	}
 
-	g_signal_emit(G_OBJECT(user_data), signals[SHOW_MENU], 0, entry, timestamp, TRUE);
+	g_signal_emit_by_name(G_OBJECT(user_data), WINDOW_MENU_SIGNAL_SHOW_MENU, entry, timestamp, TRUE);
 
 	return;
 }
@@ -387,22 +345,27 @@
 static void
 status_changed (DbusmenuClient * client, GParamSpec * pspec, gpointer user_data)
 {
-	g_signal_emit(G_OBJECT(user_data), signals[STATUS_CHANGED], 0, dbusmenu_client_get_status (client));
+	g_signal_emit_by_name(G_OBJECT(user_data), WINDOW_MENU_SIGNAL_STATUS_CHANGED, dbusmenu_client_get_status (client));
 }
 
-DbusmenuStatus
-window_menus_get_status (WindowMenus * wm)
+WindowMenuStatus dbusmenu_status_table[] = {
+	[DBUSMENU_STATUS_NORMAL] = WINDOW_MENU_STATUS_NORMAL,
+	[DBUSMENU_STATUS_NOTICE] = WINDOW_MENU_STATUS_ACTIVE
+};
+
+static WindowMenuStatus
+get_status (WindowMenu * wm)
 {
-	g_return_val_if_fail(IS_WINDOW_MENUS(wm), DBUSMENU_STATUS_NORMAL);
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), DBUSMENU_STATUS_NORMAL);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 
-	return dbusmenu_client_get_status (DBUSMENU_CLIENT (priv->client));
+	return dbusmenu_status_table[dbusmenu_client_get_status (DBUSMENU_CLIENT (priv->client))];
 }
 
 /* Build a new window menus object and attach to the signals to build
    up the representative menu. */
-WindowMenus *
-window_menus_new (const guint windowid, const gchar * dbus_addr, const gchar * dbus_object)
+WindowMenuDbusmenu *
+window_menu_dbusmenu_new (const guint windowid, const gchar * dbus_addr, const gchar * dbus_object)
 {
 	g_debug("Creating new windows menu: %X, %s, %s", windowid, dbus_addr, dbus_object);
 
@@ -410,8 +373,8 @@
 	g_return_val_if_fail(dbus_addr != NULL, NULL);
 	g_return_val_if_fail(dbus_object != NULL, NULL);
 
-	WindowMenus * newmenu = WINDOW_MENUS(g_object_new(WINDOW_MENUS_TYPE, NULL));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(newmenu);
+	WindowMenuDbusmenu * newmenu = WINDOW_MENU_DBUSMENU(g_object_new(WINDOW_MENU_DBUSMENU_TYPE, NULL));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(newmenu);
 
 	priv->windowid = windowid;
 
@@ -459,10 +422,10 @@
 		return; // Must exit before accessing freed memory
 	}
 
-	WindowMenus * self = WINDOW_MENUS(user_data);
+	WindowMenuDbusmenu * self = WINDOW_MENU_DBUSMENU(user_data);
 	g_return_if_fail(self != NULL);
 
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(self);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(self);
 
 	if (priv->props_cancel != NULL) {
 		g_object_unref(priv->props_cancel);
@@ -486,15 +449,17 @@
 }
 
 /* Get the location of this entry */
-guint
-window_menus_get_location (WindowMenus * wm, IndicatorObjectEntry * entry)
+static guint
+get_location (WindowMenu * wm, IndicatorObjectEntry * entry)
 {
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), 0);
+
 	if (entry == NULL) {
 		return 0;
 	}
 
 	guint i;
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	for (i = 0; i < priv->entries->len; i++) {
 		if (entry == g_array_index(priv->entries, IndicatorObjectEntry *, i)) {
 			break;
@@ -509,11 +474,11 @@
 }
 
 /* Get the entries that we have */
-GList *
-window_menus_get_entries (WindowMenus * wm)
+static GList *
+get_entries (WindowMenu * wm)
 {
-	g_return_val_if_fail(IS_WINDOW_MENUS(wm), NULL);
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), NULL);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 
 	int i;
 	GList * output = NULL;
@@ -532,7 +497,7 @@
 static void
 new_root_helper (DbusmenuMenuitem * item, gpointer user_data)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 	menu_entry_added(dbusmenu_client_get_root(DBUSMENU_CLIENT(priv->client)), item, priv->entries->len, user_data);
 	return;
 }
@@ -554,8 +519,8 @@
 static void
 root_changed (DbusmenuClient * client, DbusmenuMenuitem * new_root, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	/* Remove the old entries */
 	free_entries(G_OBJECT(user_data), TRUE);
@@ -596,8 +561,8 @@
 static void
 menu_entry_added (DbusmenuMenuitem * root, DbusmenuMenuitem * newentry, guint position, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	g_signal_connect(G_OBJECT(newentry), DBUSMENU_MENUITEM_SIGNAL_REALIZED, G_CALLBACK(menu_entry_realized), user_data);
 
@@ -638,8 +603,8 @@
 static void
 menu_entry_realized (DbusmenuMenuitem * newentry, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	GtkMenu * menu = dbusmenu_gtkclient_menuitem_get_submenu(priv->client, newentry);
 
@@ -696,7 +661,7 @@
 		entry->accessible_desc = g_variant_get_string(value, NULL);
 
 		if (wmentry->wm != NULL) {
-			g_signal_emit(G_OBJECT(wmentry->wm), A11Y_UPDATE, 0, entry, TRUE);
+			g_signal_emit_by_name(G_OBJECT(wmentry->wm), WINDOW_MENU_SIGNAL_A11Y_UPDATE, entry, TRUE);
 		}
 	}
 
@@ -709,7 +674,7 @@
 {
 	/* Grab our values out to stack variables */
 	DbusmenuMenuitem * newentry = DBUSMENU_MENUITEM(((gpointer *)user_data)[1]);
-	WindowMenus * wm = WINDOW_MENUS(((gpointer *)user_data)[0]);
+	WindowMenuDbusmenu * wm = WINDOW_MENU_DBUSMENU(((gpointer *)user_data)[0]);
 
 	g_return_if_fail(newentry != NULL);
 	g_return_if_fail(wm != NULL);
@@ -725,7 +690,7 @@
 		g_signal_handlers_disconnect_by_func(G_OBJECT(child), menu_child_realized, user_data);
 	}
 
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	WMEntry * wmentry = g_new0(WMEntry, 1);
 	wmentry->wm = wm;
 	IndicatorObjectEntry * entry = &wmentry->ioentry;
@@ -770,7 +735,7 @@
 
 	g_array_append_val(priv->entries, wmentry);
 
-	g_signal_emit(G_OBJECT(wm), signals[ENTRY_ADDED], 0, entry, TRUE);
+	g_signal_emit_by_name(G_OBJECT(wm), WINDOW_MENU_SIGNAL_ENTRY_ADDED, entry, TRUE);
 
 	g_object_unref(newentry);
 
@@ -794,20 +759,20 @@
 static void
 menu_entry_removed (DbusmenuMenuitem * root, DbusmenuMenuitem * oldentry, gpointer user_data)
 {
-	g_return_if_fail(IS_WINDOW_MENUS(user_data));
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(user_data));
 	g_return_if_fail(DBUSMENU_IS_MENUITEM(oldentry));
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(user_data);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(user_data);
 
 	if (priv->entries == NULL || priv->entries->len == 0) {
 		return;
 	}
 
 	guint position;
-	IndicatorObjectEntry * entry = get_entry(WINDOW_MENUS(user_data), oldentry, &position);
+	IndicatorObjectEntry * entry = get_entry(WINDOW_MENU_DBUSMENU(user_data), oldentry, &position);
 
 	if (entry != NULL) {
 		g_array_remove_index(priv->entries, position);
-		g_signal_emit(G_OBJECT(user_data), signals[ENTRY_REMOVED], 0, entry, TRUE);
+		g_signal_emit_by_name(G_OBJECT(user_data), WINDOW_MENU_SIGNAL_ENTRY_REMOVED, entry, TRUE);
 		entry_free(entry);
 	} else {
 		/* We've been called before menu_child_realized fired,
@@ -821,18 +786,20 @@
 }
 
 /* Get the XID of this window */
-guint
-window_menus_get_xid (WindowMenus * wm)
+static guint
+get_xid (WindowMenu * wm)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), 0);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	return priv->windowid;
 }
 
 /* Get the path for this object */
 gchar *
-window_menus_get_path (WindowMenus * wm)
+window_menu_dbusmenu_get_path (WindowMenuDbusmenu * wm)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), NULL);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	GValue obj = {0};
 	g_value_init(&obj, G_TYPE_STRING);
 	g_object_get_property(G_OBJECT(priv->client), DBUSMENU_CLIENT_PROP_DBUS_OBJECT, &obj);
@@ -843,9 +810,10 @@
 
 /* Get the address of this object */
 gchar *
-window_menus_get_address (WindowMenus * wm)
+window_menu_dbusmenu_get_address (WindowMenuDbusmenu * wm)
 {
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), NULL);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	GValue obj = {0};
 	g_value_init(&obj, G_TYPE_STRING);
 	g_object_get_property(G_OBJECT(priv->client), DBUSMENU_CLIENT_PROP_DBUS_NAME, &obj);
@@ -855,20 +823,21 @@
 }
 
 /* Return whether we're in an error state or not */
-gboolean
-window_menus_get_error_state (WindowMenus * wm)
+static gboolean
+get_error_state (WindowMenu * wm)
 {
-	g_return_val_if_fail(IS_WINDOW_MENUS(wm), TRUE);
-	WindowMenusPrivate * priv = WINDOW_MENUS_GET_PRIVATE(wm);
+	g_return_val_if_fail(IS_WINDOW_MENU_DBUSMENU(wm), TRUE);
+	WindowMenuDbusmenuPrivate * priv = WINDOW_MENU_DBUSMENU_GET_PRIVATE(wm);
 	return priv->error_state;
 }
 
 /* Regain whether we're supposed to be hidden or disabled, we
    want to keep that if that's the case, otherwise bring back
    to the base state */
-void
-window_menus_entry_restore (WindowMenus * wm, IndicatorObjectEntry * entry)
+static void
+entry_restore (WindowMenu * wm, IndicatorObjectEntry * entry)
 {
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(wm));
 	WMEntry * wmentry = (WMEntry *)entry;
 
 	if (entry->label != NULL) {
@@ -894,9 +863,10 @@
 
 /* Signaled when the menu item is activated on the panel so we
    can pass it down the stack. */
-void
-window_menus_entry_activate (WindowMenus * wm, IndicatorObjectEntry * entry, guint timestamp)
+static void
+entry_activate (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp)
 {
+	g_return_if_fail(IS_WINDOW_MENU_DBUSMENU(wm));
 	WMEntry * wme = (WMEntry *)entry;
 	dbusmenu_menuitem_send_about_to_show(wme->mi, NULL, NULL);
 	return;

=== renamed file 'src/window-menus.h' => 'src/window-menu-dbusmenu.h'
--- src/window-menus.h	2012-01-27 17:05:10 +0000
+++ src/window-menu-dbusmenu.h	2012-03-18 18:13:55 +0000
@@ -19,64 +19,35 @@
 with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef __WINDOW_MENUS_H__
-#define __WINDOW_MENUS_H__
+#ifndef __WINDOW_MENU_DBUSMENU_H__
+#define __WINDOW_MENU_DBUSMENU_H__
 
-#include <glib-object.h>
-#include <libindicator/indicator-object.h>
-#include <libdbusmenu-glib/client.h>
+#include "window-menu.h"
 
 G_BEGIN_DECLS
 
-#define WINDOW_MENUS_TYPE            (window_menus_get_type ())
-#define WINDOW_MENUS(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), WINDOW_MENUS_TYPE, WindowMenus))
-#define WINDOW_MENUS_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), WINDOW_MENUS_TYPE, WindowMenusClass))
-#define IS_WINDOW_MENUS(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WINDOW_MENUS_TYPE))
-#define IS_WINDOW_MENUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WINDOW_MENUS_TYPE))
-#define WINDOW_MENUS_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), WINDOW_MENUS_TYPE, WindowMenusClass))
-
-#define WINDOW_MENUS_SIGNAL_ENTRY_ADDED    "entry-added"
-#define WINDOW_MENUS_SIGNAL_ENTRY_REMOVED  "entry-removed"
-#define WINDOW_MENUS_SIGNAL_ERROR_STATE    "error-state"
-#define WINDOW_MENUS_SIGNAL_STATUS_CHANGED "status-changed"
-#define WINDOW_MENUS_SIGNAL_SHOW_MENU      "show-menu"
-#define WINDOW_MENUS_SIGNAL_A11Y_UPDATE    "a11y-update"
-
-typedef struct _WindowMenus      WindowMenus;
-typedef struct _WindowMenusClass WindowMenusClass;
-
-struct _WindowMenusClass {
-	GObjectClass parent_class;
-
-	/* Signals */
-	void (*entry_added)   (WindowMenus * wm, IndicatorObjectEntry * entry, gpointer user_data);
-	void (*entry_removed) (WindowMenus * wm, IndicatorObjectEntry * entry, gpointer user_data);
-
-	void (*error_state)   (WindowMenus * wm, gboolean state, gpointer user_data);
-	void (*status_changed) (WindowMenus * wm, DbusmenuStatus status, gpointer user_data);
-
-	void (*show_menu)     (WindowMenus * wm, IndicatorObjectEntry * entry, guint timestamp, gpointer user_data);
-	void (*a11y_update)   (WindowMenus * wm, IndicatorObjectEntry * entry, gpointer user_data);
-};
-
-struct _WindowMenus {
-	GObject parent;
-};
-
-GType window_menus_get_type (void);
-WindowMenus * window_menus_new (const guint windowid, const gchar * dbus_addr, const gchar * dbus_object);
-GList * window_menus_get_entries (WindowMenus * wm);
-guint window_menus_get_location (WindowMenus * wm, IndicatorObjectEntry * entry);
-
-guint window_menus_get_xid (WindowMenus * wm);
-gchar * window_menus_get_path (WindowMenus * wm);
-gchar * window_menus_get_address (WindowMenus * wm);
-
-gboolean window_menus_get_error_state (WindowMenus * wm);
-DbusmenuStatus window_menus_get_status (WindowMenus * wm);
-void window_menus_entry_restore (WindowMenus * wm, IndicatorObjectEntry * entry);
-
-void window_menus_entry_activate (WindowMenus * wm, IndicatorObjectEntry * entry, guint timestamp);
+#define WINDOW_MENU_DBUSMENU_TYPE            (window_menu_dbusmenu_get_type ())
+#define WINDOW_MENU_DBUSMENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), WINDOW_MENU_DBUSMENU_TYPE, WindowMenuDbusmenu))
+#define WINDOW_MENU_DBUSMENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), WINDOW_MENU_DBUSMENU_TYPE, WindowMenuDbusmenuClass))
+#define IS_WINDOW_MENU_DBUSMENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WINDOW_MENU_DBUSMENU_TYPE))
+#define IS_WINDOW_MENU_DBUSMENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WINDOW_MENU_DBUSMENU_TYPE))
+#define WINDOW_MENU_DBUSMENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), WINDOW_MENU_DBUSMENU_TYPE, WindowMenuDbusmenuClass))
+
+typedef struct _WindowMenuDbusmenu      WindowMenuDbusmenu;
+typedef struct _WindowMenuDbusmenuClass WindowMenuDbusmenuClass;
+
+struct _WindowMenuDbusmenuClass {
+	WindowMenuClass parent_class;
+};
+
+struct _WindowMenuDbusmenu {
+	WindowMenu parent;
+};
+
+GType window_menu_dbusmenu_get_type (void);
+WindowMenuDbusmenu * window_menu_dbusmenu_new (const guint windowid, const gchar * dbus_addr, const gchar * dbus_object);
+gchar * window_menu_dbusmenu_get_path (WindowMenuDbusmenu * wm);
+gchar * window_menu_dbusmenu_get_address (WindowMenuDbusmenu * wm);
 
 G_END_DECLS
 

=== added file 'src/window-menu-model.c'
--- src/window-menu-model.c	1970-01-01 00:00:00 +0000
+++ src/window-menu-model.c	2012-03-18 18:20:50 +0000
@@ -0,0 +1,288 @@
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <libbamf/libbamf.h>
+#include <gio/gio.h>
+#include <gtk/gtk.h>
+#include <glib/gi18n.h>
+
+#include "window-menu-model.h"
+#include "gactionmuxer.h"
+
+struct _WindowMenuModelPrivate {
+	guint xid;
+
+	/* All the actions */
+	GActionMuxer * action_mux;
+
+	/* Application Menu */
+	GDBusMenuModel * app_menu_model;
+	IndicatorObjectEntry application_menu;
+	gboolean has_application_menu;
+
+	/* Window Menus */
+	GDBusMenuModel * win_menu_model;
+};
+
+#define WINDOW_MENU_MODEL_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), WINDOW_MENU_MODEL_TYPE, WindowMenuModelPrivate))
+
+/* Base class stuff */
+static void                window_menu_model_class_init (WindowMenuModelClass *klass);
+static void                window_menu_model_init       (WindowMenuModel *self);
+static void                window_menu_model_dispose    (GObject *object);
+static void                window_menu_model_finalize   (GObject *object);
+
+/* Window Menu subclassin' */
+static GList *             get_entries                  (WindowMenu * wm);
+static guint               get_location                 (WindowMenu * wm,
+                                                         IndicatorObjectEntry * entry);
+static WindowMenuStatus    get_status                   (WindowMenu * wm);
+static gboolean            get_error_state              (WindowMenu * wm);
+static guint               get_xid                      (WindowMenu * wm);
+
+/* GLib boilerplate */
+G_DEFINE_TYPE (WindowMenuModel, window_menu_model, WINDOW_MENU_TYPE);
+
+/* Prefixes to the action muxer */
+#define ACTION_MUX_PREFIX_WIN  "window"
+#define ACTION_MUX_PREFIX_APP  "application"
+
+static void
+window_menu_model_class_init (WindowMenuModelClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (WindowMenuModelPrivate));
+
+	object_class->dispose = window_menu_model_dispose;
+	object_class->finalize = window_menu_model_finalize;
+
+	WindowMenuClass * wm_class = WINDOW_MENU_CLASS(klass);
+
+	wm_class->get_entries = get_entries;
+	wm_class->get_location = get_location;
+	wm_class->get_status = get_status;
+	wm_class->get_error_state = get_error_state;
+	wm_class->get_xid = get_xid;
+
+	return;
+}
+
+static void
+window_menu_model_init (WindowMenuModel *self)
+{
+	self->priv = WINDOW_MENU_MODEL_GET_PRIVATE(self);
+
+	self->priv->action_mux = g_action_muxer_new();
+
+	return;
+}
+
+static void
+window_menu_model_dispose (GObject *object)
+{
+	WindowMenuModel * menu = WINDOW_MENU_MODEL(object);
+
+	g_clear_object(&menu->priv->action_mux);
+
+	/* Application Menu */
+	g_clear_object(&menu->priv->app_menu_model);
+	g_clear_object(&menu->priv->application_menu.label);
+	g_clear_object(&menu->priv->application_menu.menu);
+
+	/* Window Menus */
+	g_clear_object(&menu->priv->win_menu_model);
+
+	G_OBJECT_CLASS (window_menu_model_parent_class)->dispose (object);
+	return;
+}
+
+static void
+window_menu_model_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (window_menu_model_parent_class)->finalize (object);
+	return;
+}
+
+/* Adds the application menu and turns the whole thing into an object
+   entry that can be used elsewhere */
+static void
+add_application_menu (WindowMenuModel * menu, const gchar * appname, GMenuModel * model)
+{
+	g_return_if_fail(G_IS_MENU_MODEL(model));
+
+	menu->priv->app_menu_model = g_object_ref(model);
+
+	if (appname != NULL) {
+		menu->priv->application_menu.label = GTK_LABEL(gtk_label_new(appname));
+	} else {
+		menu->priv->application_menu.label = GTK_LABEL(gtk_label_new(_("Unknown Application Name")));
+	}
+	g_object_ref_sink(menu->priv->application_menu.label);
+	gtk_widget_show(GTK_WIDGET(menu->priv->application_menu.label));
+
+	menu->priv->application_menu.menu = GTK_MENU(gtk_menu_new());
+
+	GtkWidget * item = gtk_menu_item_new_with_label("Test");
+	gtk_widget_show(item);
+	gtk_menu_shell_append(GTK_MENU_SHELL(menu->priv->application_menu.menu), item);
+
+	gtk_widget_show(GTK_WIDGET(menu->priv->application_menu.menu));
+	g_object_ref_sink(menu->priv->application_menu.menu);
+
+	menu->priv->has_application_menu = TRUE;
+
+	return;
+}
+
+/* Adds the window menu and turns it into a set of IndicatorObjectEntries
+   that can be used elsewhere */
+static void
+add_window_menu (WindowMenuModel * menu, GMenuModel * model)
+{
+	menu->priv->win_menu_model = g_object_ref(model);
+
+
+	return;
+}
+
+/* Builds the menu model from the window for the application */
+WindowMenuModel *
+window_menu_model_new (BamfApplication * app, BamfWindow * window)
+{
+	WindowMenuModel * menu = g_object_new(WINDOW_MENU_MODEL_TYPE, NULL);
+
+	menu->priv->xid = bamf_window_get_xid(window);
+
+	gchar *unique_bus_name;
+	gchar *app_menu_object_path;
+	gchar *menubar_object_path;
+	gchar *application_object_path;
+	gchar *window_object_path;
+	GDBusConnection *session;
+
+	unique_bus_name = bamf_window_get_utf8_prop (window, "_GTK_UNIQUE_BUS_NAME");
+
+	if (unique_bus_name == NULL) {
+		/* If this isn't set, we won't get very far... */
+		return NULL;
+	}
+
+	app_menu_object_path = bamf_window_get_utf8_prop (window, "_GTK_APP_MENU_OBJECT_PATH");
+	menubar_object_path = bamf_window_get_utf8_prop (window, "_GTK_MENUBAR_OBJECT_PATH");
+	application_object_path = bamf_window_get_utf8_prop (window, "_GTK_APPLICATION_OBJECT_PATH");
+	window_object_path = bamf_window_get_utf8_prop (window, "_GTK_WINDOW_OBJECT_PATH");
+
+	session = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, NULL);
+
+	/* Setup actions */
+	if (application_object_path != NULL) {
+		g_action_muxer_insert(menu->priv->action_mux, ACTION_MUX_PREFIX_APP, G_ACTION_GROUP(g_dbus_action_group_get (session, unique_bus_name, application_object_path)));
+	}
+
+	if (window_object_path != NULL) {
+		g_action_muxer_insert(menu->priv->action_mux, ACTION_MUX_PREFIX_WIN, G_ACTION_GROUP(g_dbus_action_group_get (session, unique_bus_name, window_object_path)));
+	}
+
+	/* Build us some menus */
+	if (app_menu_object_path != NULL) {
+		GMenuModel * model = G_MENU_MODEL(g_dbus_menu_model_get (session, unique_bus_name, app_menu_object_path));
+
+		add_application_menu(menu, NULL, model);
+
+		g_object_unref(model);
+	}
+
+	if (menubar_object_path != NULL) {
+		GMenuModel * model = G_MENU_MODEL(g_dbus_menu_model_get (session, unique_bus_name, menubar_object_path));
+
+		add_window_menu(menu, model);
+
+		g_object_unref(model);
+	}
+
+	/* when the action groups change, we could end up having items
+	 * enabled/disabled.  how to deal with that?
+	 */
+
+	g_free (unique_bus_name);
+	g_free (app_menu_object_path);
+	g_free (menubar_object_path);
+	g_free (application_object_path);
+	g_free (window_object_path);
+
+	g_object_unref (session);
+
+	return menu;
+}
+
+/* Get the list of entries */
+static GList *
+get_entries (WindowMenu * wm)
+{
+	g_return_val_if_fail(IS_WINDOW_MENU_MODEL(wm), NULL);
+	WindowMenuModel * menu = WINDOW_MENU_MODEL(wm);
+
+	GList * ret = NULL;
+
+	if (menu->priv->has_application_menu) {
+		ret = g_list_append(ret, &menu->priv->application_menu);
+	}
+
+	return ret;
+}
+
+/* Find the location of an entry */
+static guint
+get_location (WindowMenu * wm, IndicatorObjectEntry * entry)
+{
+	g_return_val_if_fail(IS_WINDOW_MENU_MODEL(wm), 0);
+	WindowMenuModel * menu = WINDOW_MENU_MODEL(wm);
+
+	gboolean found = FALSE;
+	guint pos = 0;
+
+	if (menu->priv->has_application_menu) {
+		if (entry == &menu->priv->application_menu) {
+			pos = 0;
+			found = TRUE;
+		} else {
+			/* We need to put a shift in if there is an application
+			   menu and we're not looking for that one */
+			pos = 1;
+		}
+	}
+
+	if (!found) {
+		g_warning("Unable to find entry: %p", entry);
+	}
+
+	return pos;
+}
+
+/* Get's the status of the application to whether underlines should be
+   shown to the application.  GMenuModel doesn't give us this info. */
+static WindowMenuStatus
+get_status (WindowMenu * wm)
+{
+	return WINDOW_MENU_STATUS_NORMAL;
+}
+
+/* Says whether the application is in error, GMenuModel doesn't give us this
+   information on the app */
+static gboolean
+get_error_state (WindowMenu * wm)
+{
+	return FALSE;
+}
+
+/* Get the XID of this guy */
+static guint
+get_xid (WindowMenu * wm)
+{
+	g_return_val_if_fail(IS_WINDOW_MENU_MODEL(wm), 0);
+	return WINDOW_MENU_MODEL(wm)->priv->xid;
+}

=== added file 'src/window-menu-model.h'
--- src/window-menu-model.h	1970-01-01 00:00:00 +0000
+++ src/window-menu-model.h	2012-03-18 16:26:24 +0000
@@ -0,0 +1,37 @@
+#ifndef __WINDOW_MENU_MODEL_H__
+#define __WINDOW_MENU_MODEL_H__
+
+#include <glib.h>
+#include <glib-object.h>
+#include <libbamf/bamf-window.h>
+#include "window-menu.h"
+
+G_BEGIN_DECLS
+
+#define WINDOW_MENU_MODEL_TYPE            (window_menu_model_get_type ())
+#define WINDOW_MENU_MODEL(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), WINDOW_MENU_MODEL_TYPE, WindowMenuModel))
+#define WINDOW_MENU_MODEL_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), WINDOW_MENU_MODEL_TYPE, WindowMenuModelClass))
+#define IS_WINDOW_MENU_MODEL(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WINDOW_MENU_MODEL_TYPE))
+#define IS_WINDOW_MENU_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WINDOW_MENU_MODEL_TYPE))
+#define WINDOW_MENU_MODEL_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), WINDOW_MENU_MODEL_TYPE, WindowMenuModelClass))
+
+typedef struct _WindowMenuModel        WindowMenuModel;
+typedef struct _WindowMenuModelClass   WindowMenuModelClass;
+typedef struct _WindowMenuModelPrivate WindowMenuModelPrivate;
+
+struct _WindowMenuModelClass {
+	WindowMenuClass parent_class;
+};
+
+struct _WindowMenuModel {
+	WindowMenu parent;
+
+	WindowMenuModelPrivate * priv;
+};
+
+GType window_menu_model_get_type (void);
+WindowMenuModel * window_menu_model_new (BamfApplication * app, BamfWindow * window);
+
+G_END_DECLS
+
+#endif

=== added file 'src/window-menu.c'
--- src/window-menu.c	1970-01-01 00:00:00 +0000
+++ src/window-menu.c	2012-03-18 18:13:55 +0000
@@ -0,0 +1,199 @@
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "window-menu.h"
+#include "indicator-appmenu-marshal.h"
+
+#define WINDOW_MENU_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), WINDOW_MENU_TYPE, WindowMenuPrivate))
+
+/* Signals */
+
+enum {
+	ENTRY_ADDED,
+	ENTRY_REMOVED,
+	ERROR_STATE,
+	STATUS_CHANGED,
+	SHOW_MENU,
+	A11Y_UPDATE,
+	LAST_SIGNAL
+};
+
+static guint signals[LAST_SIGNAL] = { 0 };
+
+/* Prototypes */
+
+static void window_menu_class_init (WindowMenuClass *klass);
+static void window_menu_init       (WindowMenu *self);
+static void window_menu_dispose    (GObject *object);
+static void window_menu_finalize   (GObject *object);
+
+G_DEFINE_TYPE (WindowMenu, window_menu, G_TYPE_OBJECT);
+
+static void
+window_menu_class_init (WindowMenuClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	object_class->dispose = window_menu_dispose;
+	object_class->finalize = window_menu_finalize;
+
+	/* Signals */
+	signals[ENTRY_ADDED] =  g_signal_new(WINDOW_MENU_SIGNAL_ENTRY_ADDED,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, entry_added),
+	                                      NULL, NULL,
+	                                      g_cclosure_marshal_VOID__POINTER,
+	                                      G_TYPE_NONE, 1, G_TYPE_POINTER);
+	signals[ENTRY_REMOVED] =  g_signal_new(WINDOW_MENU_SIGNAL_ENTRY_REMOVED,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, entry_removed),
+	                                      NULL, NULL,
+	                                      g_cclosure_marshal_VOID__POINTER,
+	                                      G_TYPE_NONE, 1, G_TYPE_POINTER);
+	signals[ERROR_STATE] =   g_signal_new(WINDOW_MENU_SIGNAL_ERROR_STATE,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, error_state),
+	                                      NULL, NULL,
+	                                      g_cclosure_marshal_VOID__BOOLEAN,
+	                                      G_TYPE_NONE, 1, G_TYPE_BOOLEAN, G_TYPE_NONE);
+	signals[STATUS_CHANGED] = g_signal_new(WINDOW_MENU_SIGNAL_STATUS_CHANGED,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, status_changed),
+	                                      NULL, NULL,
+	                                      g_cclosure_marshal_VOID__INT,
+	                                      G_TYPE_NONE, 1, G_TYPE_INT, G_TYPE_NONE);
+	signals[SHOW_MENU] =     g_signal_new(WINDOW_MENU_SIGNAL_SHOW_MENU,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, show_menu),
+	                                      NULL, NULL,
+	                                      _indicator_appmenu_marshal_VOID__POINTER_UINT,
+	                                      G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_UINT, G_TYPE_NONE);
+	signals[A11Y_UPDATE] =   g_signal_new(WINDOW_MENU_SIGNAL_A11Y_UPDATE,
+	                                      G_TYPE_FROM_CLASS(klass),
+	                                      G_SIGNAL_RUN_LAST,
+	                                      G_STRUCT_OFFSET (WindowMenuClass, a11y_update),
+	                                      NULL, NULL,
+	                                      _indicator_appmenu_marshal_VOID__POINTER,
+	                                      G_TYPE_NONE, 1, G_TYPE_POINTER, G_TYPE_NONE);
+
+	return;
+}
+
+static void
+window_menu_init (WindowMenu *self)
+{
+
+
+	return;
+}
+
+static void
+window_menu_dispose (GObject *object)
+{
+
+	G_OBJECT_CLASS (window_menu_parent_class)->dispose (object);
+	return;
+}
+
+static void
+window_menu_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (window_menu_parent_class)->finalize (object);
+	return;
+}
+
+
+/**************************
+  API
+ **************************/
+GList *
+window_menu_get_entries (WindowMenu * wm)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->get_entries != NULL) {
+		return class->get_entries(wm);
+	} else {
+		return NULL;
+	}
+}
+
+guint
+window_menu_get_location (WindowMenu * wm, IndicatorObjectEntry * entry)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->get_location != NULL) {
+		return class->get_location(wm, entry);
+	} else {
+		return 0;
+	}
+}
+
+guint
+window_menu_get_xid (WindowMenu * wm)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->get_xid != NULL) {
+		return class->get_xid(wm);
+	} else {
+		return 0;
+	}
+}
+
+gboolean
+window_menu_get_error_state (WindowMenu * wm)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->get_error_state != NULL) {
+		return class->get_error_state(wm);
+	} else {
+		return TRUE;
+	}
+}
+
+WindowMenuStatus
+window_menu_get_status (WindowMenu * wm)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->get_status != NULL) {
+		return class->get_status(wm);
+	} else {
+		return WINDOW_MENU_STATUS_NORMAL;
+	}
+}
+
+void
+window_menu_entry_restore (WindowMenu * wm, IndicatorObjectEntry * entry)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->entry_restore != NULL) {
+		return class->entry_restore(wm, entry);
+	} else {
+		return;
+	}
+}
+
+void
+window_menu_entry_activate (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp)
+{
+	WindowMenuClass * class = WINDOW_MENU_GET_CLASS(wm);
+
+	if (class->entry_activate != NULL) {
+		return class->entry_activate(wm, entry, timestamp);
+	} else {
+		return;
+	}
+}

=== added file 'src/window-menu.h'
--- src/window-menu.h	1970-01-01 00:00:00 +0000
+++ src/window-menu.h	2012-03-18 18:13:55 +0000
@@ -0,0 +1,98 @@
+/*
+An implementation of indicator object showing menus from applications.
+
+Copyright 2012 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __WINDOW_MENU_H__
+#define __WINDOW_MENU_H__
+
+#include <glib-object.h>
+#include <libindicator/indicator-object.h>
+
+G_BEGIN_DECLS
+
+#define WINDOW_MENU_TYPE             (window_menu_get_type ())
+#define WINDOW_MENU(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), WINDOW_MENU_TYPE, WindowMenu))
+#define WINDOW_MENU_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), WINDOW_MENU_TYPE, WindowMenuClass))
+#define IS_WINDOW_MENU(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WINDOW_MENU_TYPE))
+#define IS_WINDOW_MENU_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), WINDOW_MENU_TYPE))
+#define WINDOW_MENU_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), WINDOW_MENU_TYPE, WindowMenuClass))
+
+#define WINDOW_MENU_SIGNAL_ENTRY_ADDED    "entry-added"
+#define WINDOW_MENU_SIGNAL_ENTRY_REMOVED  "entry-removed"
+#define WINDOW_MENU_SIGNAL_ERROR_STATE    "error-state"
+#define WINDOW_MENU_SIGNAL_STATUS_CHANGED "status-changed"
+#define WINDOW_MENU_SIGNAL_SHOW_MENU      "show-menu"
+#define WINDOW_MENU_SIGNAL_A11Y_UPDATE    "a11y-update"
+
+typedef enum _WindowMenuStatus WindowMenuStatus;
+enum _WindowMenuStatus {
+	WINDOW_MENU_STATUS_NORMAL,
+	WINDOW_MENU_STATUS_ACTIVE
+};
+
+typedef struct _WindowMenu      WindowMenu;
+typedef struct _WindowMenuClass WindowMenuClass;
+
+struct _WindowMenuClass {
+	GObjectClass parent_class;
+
+	/* Virtual Funcs */
+	GList *          (*get_entries)      (WindowMenu * wm);
+	guint            (*get_location)     (WindowMenu * wm, IndicatorObjectEntry * entry);
+
+	guint            (*get_xid)          (WindowMenu * wm);
+
+	gboolean         (*get_error_state)  (WindowMenu * wm);
+	WindowMenuStatus (*get_status)       (WindowMenu * wm);
+	void             (*entry_restore)    (WindowMenu * wm, IndicatorObjectEntry * entry);
+
+	void             (*entry_activate)   (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp);
+
+	/* Signals */
+	void (*entry_added)    (WindowMenu * wm, IndicatorObjectEntry * entry, gpointer user_data);
+	void (*entry_removed)  (WindowMenu * wm, IndicatorObjectEntry * entry, gpointer user_data);
+
+	void (*error_state)    (WindowMenu * wm, gboolean state, gpointer user_data);
+	void (*status_changed) (WindowMenu * wm, WindowMenuStatus status, gpointer user_data);
+
+	void (*show_menu)      (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp, gpointer user_data);
+	void (*a11y_update)    (WindowMenu * wm, IndicatorObjectEntry * entry, gpointer user_data);
+};
+
+struct _WindowMenu {
+	GObject parent;
+};
+
+GType window_menu_get_type (void);
+
+GList * window_menu_get_entries (WindowMenu * wm);
+guint window_menu_get_location (WindowMenu * wm, IndicatorObjectEntry * entry);
+
+guint window_menu_get_xid (WindowMenu * wm);
+
+gboolean window_menu_get_error_state (WindowMenu * wm);
+WindowMenuStatus window_menu_get_status (WindowMenu * wm);
+void window_menu_entry_restore (WindowMenu * wm, IndicatorObjectEntry * entry);
+
+void window_menu_entry_activate (WindowMenu * wm, IndicatorObjectEntry * entry, guint timestamp);
+
+G_END_DECLS
+
+#endif

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2012-03-06 19:40:56 +0000
+++ tests/Makefile.am	2012-03-12 18:52:56 +0000
@@ -43,6 +43,7 @@
 	-Wall -Werror
 
 test_distance_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 DISTCLEANFILES += $(DISTANCE_XML_REPORT)
@@ -84,6 +85,7 @@
 	-Wall -Werror
 
 test_usage_db_simple_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 DISTCLEANFILES += $(USAGE_DB_SIMPLE_XML_REPORT)
@@ -126,6 +128,7 @@
 	-Wall -Werror
 
 test_usage_db_old_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 DISTCLEANFILES += $(USAGE_DB_OLD_XML_REPORT)
@@ -170,6 +173,7 @@
 	-Wall -Werror
 
 test_usage_db_ancient_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 EXTRA_DIST += \
@@ -214,6 +218,7 @@
 	-Wall -Werror
 
 test_usage_db_testapp_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 EXTRA_DIST += \
@@ -319,6 +324,7 @@
 	-Wall -Werror
 
 test_bad_app_info_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 #########################
@@ -342,6 +348,7 @@
 	-Wall -Werror
 
 test_load_app_info_LDADD = \
+	../src/libhud-service.a		\
 	$(HUD_LIBS)
 
 test-good-app-info-tons-of-entries: good-app-info/tons-of-entries.hud-app-info test-load-app-info test-usage-dump-entries.sql Makefile.am

=== modified file 'tests/test-bad-app-info.c'
--- tests/test-bad-app-info.c	2011-11-27 19:19:32 +0000
+++ tests/test-bad-app-info.c	2012-03-12 18:52:56 +0000
@@ -24,7 +24,6 @@
 #include <glib/gstdio.h>
 #include <glib-object.h>
 #include "load-app-info.h"
-#include "load-app-info.c"
 
 static void
 build_db (sqlite3 * db)

=== modified file 'tests/test-distance.c'
--- tests/test-distance.c	2012-03-05 17:44:12 +0000
+++ tests/test-distance.c	2012-03-12 18:52:56 +0000
@@ -22,9 +22,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
-#define DUMP_MATRIX 1
+#include "hudsettings.h"
 #include "distance.h"
-#include "distance.c"
 
 /* hardcode some parameters so the test doesn't fail if the user
  * has bogus things in GSettings.

=== modified file 'tests/test-load-app-info.c'
--- tests/test-load-app-info.c	2011-11-27 20:21:13 +0000
+++ tests/test-load-app-info.c	2012-03-12 18:52:56 +0000
@@ -24,7 +24,6 @@
 #include <glib/gstdio.h>
 #include <glib-object.h>
 #include "load-app-info.h"
-#include "load-app-info.c"
 
 static void
 build_db (sqlite3 * db)

=== modified file 'tests/test-usage-db-ancient.c'
--- tests/test-usage-db-ancient.c	2012-03-05 19:24:40 +0000
+++ tests/test-usage-db-ancient.c	2012-03-12 18:52:56 +0000
@@ -22,11 +22,9 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "hudsettings.h"
 #include "load-app-info.h"
-#include "load-app-info.c"
 #include "usage-tracker.h"
-#include "usage-tracker.c"
-#include "create-db.c"
 
 HudSettings hud_settings = {
   .store_usage_data = TRUE

=== modified file 'tests/test-usage-db-old.c'
--- tests/test-usage-db-old.c	2012-03-05 19:24:40 +0000
+++ tests/test-usage-db-old.c	2012-03-12 18:52:56 +0000
@@ -22,11 +22,9 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "hudsettings.h"
 #include "load-app-info.h"
-#include "load-app-info.c"
 #include "usage-tracker.h"
-#include "usage-tracker.c"
-#include "create-db.c"
 
 HudSettings hud_settings = {
   .store_usage_data = TRUE

=== modified file 'tests/test-usage-db-simple.c'
--- tests/test-usage-db-simple.c	2012-03-05 19:24:40 +0000
+++ tests/test-usage-db-simple.c	2012-03-12 18:52:56 +0000
@@ -22,11 +22,9 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "hudsettings.h"
 #include "load-app-info.h"
-#include "load-app-info.c"
 #include "usage-tracker.h"
-#include "usage-tracker.c"
-#include "create-db.c"
 
 HudSettings hud_settings = {
   .store_usage_data = TRUE

=== modified file 'tests/test-usage-db-testapp.c'
--- tests/test-usage-db-testapp.c	2012-03-05 19:24:40 +0000
+++ tests/test-usage-db-testapp.c	2012-03-12 18:52:56 +0000
@@ -22,13 +22,10 @@
 #include <glib.h>
 #include <glib-object.h>
 
-#define DUMP_MATRIX 1
+#include "hudsettings.h"
 #include "load-app-info.h"
-#include "load-app-info.c"
 #include "usage-tracker.h"
-#include "usage-tracker.c"
 #include "shared-values.h"
-#include "create-db.c"
 
 HudSettings hud_settings = {
   .store_usage_data = TRUE

